/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import edu.uoc.Android.LiveUOC.Objectes.Aula;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;


public class AulesActivity extends Activity {

	// Atribut per a emmagatzemar les aules:
	private Aula[] LlistaAules;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Recollim la informaci de les aules
        getAules();
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.aules);
        
        // Creem l'adapter per ficar la llista d'aules.
        AdaptadorAules adaptador = new AdaptadorAules(this);
        
        // Capturem la ID de la vista de llistat
        ListView lstAules = (ListView)findViewById(R.id.listViewAules);
        
        // Establim el llistat d'aules a la vista, mitjanant l'adapter
        lstAules.setAdapter(adaptador);

        
        /*
         * Capturem la pulsaci a un tem de la llista
         */
        // Creem el seu onClickListener
        OnItemClickListener oclItemAules = new OnItemClickListener(){
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				ListAdapter la = (ListAdapter) parent.getAdapter();
				int items = la.getCount();
				
				// DEBUG:
				Log.d("AULES", "Aules: " + items);
				
				if (items>0) {
					// DEBUG:
					Log.d("AULES", "Aula seleccionada: " + position);
					// Mostrem info
					Toast.makeText(
							view.getContext(), 
							"Accedim a l'aula:\n" +
							"CODI: " + LlistaAules[position].getCodi() +
							"\nASSIGNATURA: " + LlistaAules[position].getAssignatura() , 
							Toast.LENGTH_LONG
							).show();

					// Creem un intent per llenar la sub-activity Mostra Aula
					Intent intent = new Intent();

					// Ho associem amb la Activity a llenar
					intent.setClass(getApplicationContext(), MostraAulaActivity.class);
					
					// Creem un Bundle per passar dades al Intent
					Bundle bundle = new Bundle();
					
					// Fiquem les dades de l'aula:
					bundle.putString("CODI", LlistaAules[position].getCodi());
					bundle.putString("ASSIGNATURA", LlistaAules[position].getAssignatura());
					
					// Introdum el Bundle a l'Intent
			        intent.putExtras(bundle);
			        
					// Llancem l'Activitat associada a l'Intent
					startActivity(intent);
					
				} else {
					Toast.makeText(view.getContext(), "Cap aula.", Toast.LENGTH_SHORT).show();
				}
		        
			}
		};
        // Registrem el seu callback
        lstAules.setOnItemClickListener(oclItemAules);
        
        /*
         * Capturem els botons:
         * 		botoSortir		-> Torna enrera
         * 
         */
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);

        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
		
        
	}

	class AdaptadorAules extends ArrayAdapter<Object> {
    	
    	Activity context;
    	
    	AdaptadorAules(Activity context) {
    		super(context, R.layout.listitemaula, LlistaAules);
    		this.context = context;
    	}
    	
    	public View getView(int position, View convertView, ViewGroup parent) {
			LayoutInflater inflater = context.getLayoutInflater();
			View item = inflater.inflate(R.layout.listitemaula, null);
			
			TextView lblTitulo = (TextView)item.findViewById(R.id.LstCodiAula);
			lblTitulo.setText(LlistaAules[position].getCodi());
			
			TextView lblSubtitulo = (TextView)item.findViewById(R.id.LstAssigAula);
			lblSubtitulo.setText(LlistaAules[position].getAssignatura());
			
			return(item);
		}
    	
    	public long getItemId(int position) { return position; }
    }

	private void getAules() {
		// TODO Introdum el llistat d'aules
		// Haurem de recorrir les dades retornades per l'API de la UOC
		
		LlistaAules = new Aula[]{
	    	new Aula("Codi_1", "Assignatura_1"),
	    	new Aula("Codi_2", "Assignatura_2"),
	    	new Aula("Codi_3", "Assignatura_3")
	    };
		
	}
}
