/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import android.app.Activity;
import android.content.Intent;
import android.net.ParseException;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.GridView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;


public class CalendariActivity extends Activity {

	// Atributs per a la data
	Calendar cal = new GregorianCalendar();
	Date dataAvui = new Date();
	String[] mesos = {
			"Gener",
			"Febrer",
			"Mar",
			"Abril",
			"Maig",
			"Juny",
			"Juliol",
			"Agost",
			"Setembre",
			"Octubre",
			"Novembre",
			"Desembre",
	};
	int mesActual = cal.get(Calendar.MONTH);
	int anyActual = cal.get(Calendar.YEAR);
	
	// Variables per als camps de text:
	TextView textMesActual;
	TextView textAnyActual;
	
	// Matriu per al GridCalendar (7 dies x 6 setmanes, mxim)
	int diesSetmana = 7;
	int numSetmanes = 6;
	int maxGrid = diesSetmana*numSetmanes;
	private String[] gridCal = new String[maxGrid];
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.calendari);
        
        /*
         * Capturem els texts cambiables:
         * 		mesActual		->	Mes actual
         * 		anyActual		->	Any actual
         * 
         */
        textMesActual = (TextView)findViewById(R.id.mesActual);
        textAnyActual = (TextView)findViewById(R.id.anyActual);
        
        // Establim els textos:
        textMesActual.setText(mesos[mesActual]);
        textAnyActual.setText(Integer.toString(anyActual));
        
        /*
         * Capturem el GridView
         * 		gridCalendar	->	Calendari
         * 
         */
        final GridView gridCalendar = (GridView)findViewById(R.id.gridCalendar);
        
        // Muntem el GridCAlendar amb el mes actual:
        muntaCalendari();
        
        // Creem l'adapter
        final ArrayAdapter<String> adaptador =
              new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, gridCal);
       
        // Establim l'adaptador al GridView
        gridCalendar.setAdapter(adaptador);
        
        
        /*
         * Capturem els botons:
         * 		botoMesAnt		-> Retrocedeix un mes
         * 		botoMesSeg		-> Avana un mes
         * 		botoSortir		-> Torna enrera
         * 
         */
        final Button botoMesAnt = (Button) findViewById(R.id.botoMesAnt);
        final Button botoMesSeg = (Button) findViewById(R.id.botoMesSeg);
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);
        
        // Pulsaci del Bot MesAnt
        // Creem el seu onClickListener
        OnClickListener oclbotoMesAnt = new OnClickListener(){
			public void onClick(View v) {
				// Retrocedim un mes
				cal.add(Calendar.MONTH, -1);
				int mesActual = cal.get(Calendar.MONTH);
				int anyActual = cal.get(Calendar.YEAR);
				
				// Establim els textos:
				textMesActual.setText(mesos[mesActual]);
		        textAnyActual.setText(Integer.toString(anyActual));
		        
		        // TODO: Actualitzar el grid del mes:
		        muntaCalendari();
		        adaptador.notifyDataSetChanged();
		        gridCalendar.invalidateViews();
			}
		};        
        // Registrem el seu callback
		botoMesAnt.setOnClickListener(oclbotoMesAnt);
		
        // Pulsaci del Bot MesSeg
        // Creem el seu onClickListener
        OnClickListener oclbotoMesSeg = new OnClickListener(){
			public void onClick(View v) {
				// Avancem un mes
				cal.add(Calendar.MONTH, 1);
				int mesActual = cal.get(Calendar.MONTH);
				int anyActual = cal.get(Calendar.YEAR);
				
				// Establim els textos:
				textMesActual.setText(mesos[mesActual]);
		        textAnyActual.setText(Integer.toString(anyActual));
		        
		        // TODO: Actualitzar el grid del mes:
		        muntaCalendari();
		        adaptador.notifyDataSetChanged();
		        gridCalendar.invalidateViews();
			}
		};        
        // Registrem el seu callback
		botoMesSeg.setOnClickListener(oclbotoMesSeg);
		
        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
		
		/*
         * Capturem la pulsaci a un tem del GridView
         */
        // Creem el seu onClickListener
		OnItemClickListener oclItemCalendar = new OnItemClickListener(){
			public void onItemClick(AdapterView<?> parent, android.view.View v, int position, long id) {
				// Verifiquem si a la posici seleccionada hi ha un dia vlid,
				// sino hi ha un dia, no fem res:
				if (gridCal[position]!= "") {
					// Mostrem info
					Toast.makeText(
							v.getContext(), 
							"Accedim al dia:\n" + gridCal[position] + "."
							+ (cal.get(Calendar.MONTH)+1) + "."
							+ cal.get(Calendar.YEAR), 
							Toast.LENGTH_SHORT
							).show();
					
					/*
					 *  TODO: S'ha de crear un bundle per passar info a l'activitat mostra dia
					 *  	Dia seleccionat.
					 *  	Llistat de tasques del dia.
					 */
					
					// Creem un intent per llenar la sub-activity Mostra Aula
					Intent intent = new Intent();

					// Ho associem amb la Activity a llenar
					intent.setClass(getApplicationContext(), MostraDiaActivity.class);
					
					// TODO: Creem un Bundle per passar dades al Intent
					// Bundle bundle = new Bundle();
					
					// TODO: Fiquem les dades del dia:
					// bundle.putString("CODI", LlistaAules[position].getCodi());
					
					
					// Introdum el Bundle a l'Intent
			        // TODO: intent.putExtras(bundle);
			        
					// Llancem l'Activitat associada a l'Intent
					startActivity(intent);
				}
				
			}

		};
        // Registrem el seu callback
		gridCalendar.setOnItemClickListener(oclItemCalendar);
        
	}
	
	private void muntaCalendari() {
		/*
		 *  TODO Muntar el calendari corresponent al mes actual
		 *  	Tenint en compte l'ordre correcte dels dies de la setmana
		 *  		Els mesos van de 0 a 11 (Gener ... Desembre)
		 *  		Els dies de la setmana (A) de 1 a 7 (Diumenge ... Dissabte)
		 *  		La nostra setmana (B) va de 1 a 7 (Dilluns ... Diumenge)
		 *  
		 */
		cal.setFirstDayOfWeek(Calendar.MONDAY);

		// Ens posem al primer dia del mes
		int dia = 1;
		cal.set(Calendar.DAY_OF_MONTH, dia);
		int primerDiaSetmana = cal.get(Calendar.DAY_OF_WEEK);
		// Transformem la setmana de A a B (Primer dia ser Dilluns, i Diumenge ser el 7)
		if (primerDiaSetmana == 1) {
			primerDiaSetmana = 7;
		} else {
			primerDiaSetmana--;
		}
		int maxDiesMes = cal.getActualMaximum(Calendar.DAY_OF_MONTH);
		
		// DEBUG:
		Log.d("CalendariActivity - muntaCalendari:", "primerDiaSetmana: " + primerDiaSetmana );
		Log.d("CalendariActivity - muntaCalendari:", "maxDiesMes: " + maxDiesMes );
		
		// Recorregut pel grid
		for(int i=1; i<=maxGrid; i++) {
			// Noms indiquem els dies del mes
			if (i>=primerDiaSetmana && dia<=maxDiesMes) {
				gridCal[i-1] = "" + dia;
				// DEBUG:
				Log.d("CalendariActivity - muntaCalendari:", "Any/Mes/Dia: " + cal.get(Calendar.YEAR) + "/"  
						+ (cal.get(Calendar.MONTH)+1) + "/" + dia );
				dia++;
			} else {
				gridCal[i-1] = "";
			}
		}
		
	}

	private void setDataAvui() throws java.text.ParseException {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
		
		String dia = Integer.toString(cal.get(Calendar.DATE));
		String mes = Integer.toString(cal.get(Calendar.MONTH));
		String any = Integer.toString(cal.get(Calendar.YEAR));
		
		String dt = any + "-" + mes + "-" + dia;
		
		try {
			dataAvui = format.parse(dt);
		} catch (ParseException ex) {
		    ex.printStackTrace();
		}
		
	}
}
