/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.text.ParseException;

import edu.uoc.Android.LiveUOC.Objectes.Aula;
import edu.uoc.Android.LiveUOC.Objectes.Missatge;
import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;


public class DetallMsgTaulerActivity extends Activity {

	// Atributs per a emmagatzemar una aula i les seves dades:
	private Aula aulaActiva = new Aula();
	
	// Atribut per a emmagatzemar el missatge:
	private Missatge missatgeActiu = new Missatge();
	
	// Variables per als camps de text:
	TextView textAutorMsg;
	TextView textDataMsg;
	TextView textTemaMsg;
	TextView textCosMsg;
	
	// Variables per a les imatges:
	ImageView fotoAutor;

	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Recuperem la info. que vrem passar a l'Intent amb el Bundle:
		Bundle extras = getIntent().getExtras();
		aulaActiva.setCodi(extras.getString("CODI"));
		aulaActiva.setAssignatura(extras.getString("ASSIGNATURA"));
		missatgeActiu.setAutor(extras.getString("AUTOR"));
		missatgeActiu.setTema(extras.getString("TEMA"));
		try {
			missatgeActiu.setData(extras.getString("DATA"));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
        // Recollim les dades de la API de la UOC
        recullDadesMsg();
        
        // DEBUG:
		Log.d("MOSTRA MISSATGE", "Codi Aula: " + aulaActiva.getCodi());
		Log.d("MOSTRA MISSATGE", "Assignatura Aula: " + aulaActiva.getAssignatura());
		Log.d("MOSTRA MISSATGE", "Autor: " + missatgeActiu.getAutor());
		Log.d("MOSTRA MISSATGE", "Data: " + missatgeActiu.getData());
		Log.d("MOSTRA MISSATGE", "Tema: " + missatgeActiu.getTema());
		Log.d("MOSTRA MISSATGE", "Cos Missatge: " + missatgeActiu.getCosMissatge());
		Log.d("MOSTRA MISSATGE", "Foto: " + missatgeActiu.getUriFoto());
		
        // Mostrem el layout de pantalla
        setContentView(R.layout.missatge);
        
        /*
         * Capturem els texts cambiables:
         * 		autorMsg	->	Autor del missatge	
         * 		dataMsg		->	Data del missatge
         * 		temaMsg		->	Tema del missatge
         * 		cosMsg		->	Missatge
         * 
         */
        textAutorMsg = (TextView)findViewById(R.id.autorMsg);
        textDataMsg = (TextView)findViewById(R.id.dataMsg);
        textTemaMsg = (TextView)findViewById(R.id.temaMsg);
        textCosMsg = (TextView)findViewById(R.id.cosMsg);
        
        // Establim els textos:
        textAutorMsg.setText(missatgeActiu.getAutor());
        textDataMsg.setText(missatgeActiu.getData().toString());
        textTemaMsg.setText(missatgeActiu.getTema());
        textCosMsg.setText(missatgeActiu.getCosMissatge());
        
        /*
         * Capturem les imatges cambiables:
         * 		imageFotoAutor	->	Foto del Autor
         * 
         */
        fotoAutor = (ImageView)findViewById(R.id.imageFotoAutor);
        
        // Establim la foto
        fotoAutor.setImageResource(missatgeActiu.getUriFoto());
        
        /*
         * Capturem els botons:
         * 		botoSortir	-> Torna enrera
         * 
         */
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);

        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
        
	}
	
	private void recullDadesMsg() {

		// TODO Omplir la resta de dades des de la API de la UOC
		// De moment, ho fiquem manualment:
		missatgeActiu.setCosMissatge("Cos del missatge.");
		missatgeActiu.setUriFoto(R.drawable.nofoto);
	}
}
