/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.text.ParseException;

import edu.uoc.Android.LiveUOC.Objectes.Tasca;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;


public class DetallTascaActivity extends Activity {

	// Atributs per a emmagatzemar una aula i les seves dades:
	private Tasca tascaActiva = new Tasca();
	
	// Variables per als camps de text:
	TextView textNomTasca;
	TextView textDataTasca;
	TextView textDetTasca;
		
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        /*
         *  Recuperem la info. que vrem passar a l'Intent amb el Bundle:
         *  	NOM			->	Nom de la tasca.
         *  	DESCRIPCIO	->	Descripci
         *  	DATA		->	Data de finalitzaci (el dia seleccionat)
         */
		Bundle extras = getIntent().getExtras();
		tascaActiva.setNom(extras.getString("NOM"));
		tascaActiva.setDescripcio(extras.getString("DESCRIPCIO"));
		try {
			tascaActiva.setDataFi(extras.getString("DATA"));
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// Recollim les dades de la API de la UOC
        recullDadesTasca();
		
		
        // Mostrem el layout de pantalla
        setContentView(R.layout.detalltasca);
        
        /*
         * Capturem els texts cambiables:
         * 		nomTasca	->	Nom de la tasca
         * 		dataTasca	->	Data de la tasca
         * 		detTasca	->	Descripci
         * 
         */
        textNomTasca = (TextView)findViewById(R.id.nomTasca);
        textDataTasca = (TextView)findViewById(R.id.dataTasca);
        textDetTasca = (TextView)findViewById(R.id.detTasca);
        
        // Establim els textos:
        textNomTasca.setText(tascaActiva.getNom());
        textDataTasca.setText(tascaActiva.getDataFi().toString());
        textDetTasca.setText(tascaActiva.getDescripcio());
        
        /*
         * Capturem els botons:
         * 		botoSortir	-> Torna enrera
         * 
         */
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);

        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
        
	}



	private void recullDadesTasca() {
		// TODO Omplir la resta de dades des de la API de la UOC
		// De moment, no fiquem res ms.
		
	}
}
