/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;

import edu.uoc.Android.LiveUOC.Objectes.UserLoged;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


public class MainActivity extends Activity {
	
	// Variables per a emmagatzemar l'usuari i el password
	private String usuari = new String();
	private String password = new String();
	protected int intentsLogin = 0;
	boolean usuariAutenticat = false;
	
	// Variables per als camps de text:
	EditText editUsuari;
	EditText editPassword;
	
	// Control estat: Inicialitzem
	boolean ESTAT_ONCREATE = false;
	
	// Atribut per a emmagtzemar les dades de l'usuari logejat
	protected UserLoged userLoged;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        /*
         *  Control de tornada:
         *  
         *  	Si arribem aqu des de Men principal, s'ha de complir: 
         *  		1.- usuariAutenticat ha de ser true.
         *  		2.- ESTAT_ONCREATE ha de ser false.
         *  
         *  	Llavors l'aplicaci ha de finalitzar.
         */

        if (usuariAutenticat && !ESTAT_ONCREATE) {
        	finalitza(2);
        }
        
        // Control estat: Entrem a onCreate (APP creada de nou)
        ESTAT_ONCREATE = true;
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.login);
        
        /*
         * Capturem els textes editables:
         * 		usuari
         * 		password
         */
        editUsuari = (EditText)findViewById(R.id.usuari);
        editPassword = (EditText)findViewById(R.id.password);
        
        // Netegem camps, per seguretat:
        netejacamps();
        
        /*
         * Capturem els botons:
         * 		botoLogIn	-> Llena la verificaci del login.	
         * 		botoNeteja	-> Neteja els camps de text.
         * 		botoSurt	-> Surt de l'aplicaci.
         */
        final Button botoLogIn = (Button) findViewById(R.id.botoLogIn);
        final Button botoNeteja = (Button) findViewById(R.id.botoNeteja);
        final Button botoSurt = (Button) findViewById(R.id.botoSurt);
        
        // Pulsaci del Bot Login
        // Creem el seu onClickListener
        OnClickListener oclbotoLogIn = new OnClickListener(){
			public void onClick(View v) {

				// Toast per a comunicar "paciencia" a l'usuari:
				Toast.makeText(MainActivity.this, R.string.msgEspera , Toast.LENGTH_LONG).show();
				
				// Capturem el text introdut
				setUsuari(editUsuari.getText().toString());
				setPassword(editPassword.getText().toString());
				
				// DEBUG:
				Log.d("LOGIN - ", "Usuari: " + getUsuari());
				Log.d("LOGIN - ", "Password: " + getPassword());
				Log.d("LOGIN - ", "Intents: " + intentsLogin);
				
				// Si el login s correcte, es llena l'activitat principal
				try {
					usuariAutenticat = verificaLogin();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				if (usuariAutenticat) {
					// Resetegem els intents de login:
					intentsLogin = 0;
					
					// Activem el Flag d'usuari Autenticat: 
					// Revisar si s necessari.
					usuariAutenticat = true;
					
					// Control estat: Canvi d'Activity
					ESTAT_ONCREATE = false;
					
					// Creem un Bundle per passar les dades de l'usuari:
					Bundle bundle = new Bundle();
					
					// Fiquem l'objecte JSON com a string:
					bundle.putString("JSON", userLoged.getValidatJSON().toString());
					
					// Creem el intent per a llenar l'aplicaci
					Intent intent = new Intent();
					intent.setClass(getApplicationContext(), MenuPrincipal.class);
					
					// Introduim el Bundle a l'Intent
			        intent.putExtras(bundle);
			        
			        // LLencem l'activitat
					startActivity(intent);
				} else {
					// Augmentem el comptador d'intents de login
					intentsLogin ++;
					
					// Verifiquem els intents que s'han fet
					if (intentsLogin > 3) {
						finalitza(1);
					} else {
						// Esborrem el text usuari i password i esperem altre Login
						netejacamps();
					}
				}
			}
		};        
        // Registrem el seu callback
		botoLogIn.setOnClickListener(oclbotoLogIn);
		
		// Pulsaci del Bot Neteja
        // Creem el seu onClickListener
        OnClickListener oclbotoNeteja = new OnClickListener(){
			public void onClick(View v) {
				netejacamps();
			}
		};        
        // Registrem el seu callback
		botoNeteja.setOnClickListener(oclbotoNeteja);
		
		// Pulsaci del Bot Surt
        // Creem el seu onClickListener
        OnClickListener oclbotoSurt = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSurt.setOnClickListener(oclbotoSurt);
    }
	
	/*
	 * Mtode per a la finalitzaci:
	 * 
	 * MODE:
	 * 		1.- Nmero mxim d'intents superat 
	 * 		2.- Finalitzaci per seguretat (control de tornada)
	 */
	private void finalitza(int mode) {
		switch(mode) {
			case 1:
				// Toast "S'ha superat el lmit"
				Toast.makeText(MainActivity.this, R.string.limitLoginSuperat , Toast.LENGTH_SHORT).show();
				break;
			case 2:
				// Toast "Finalitzem per seguretat"
				Toast.makeText(MainActivity.this, R.string.ProcesLoginExhaurit , Toast.LENGTH_SHORT).show();
				break;
			default:
				// Toast "Finalitzaci no definida"
				Toast.makeText(MainActivity.this, R.string.undefinedFinish , Toast.LENGTH_SHORT).show();
				break;
		}
		
		finish();
	}

	/*
	 * (non-Javadoc)
	 * @see android.app.Activity#onResume()
	 */
	@Override
	protected void onResume() {
		super.onResume();
		
		// DEBUG:
		Log.d("onResume:", "ESTAT_ONCREATE: " + ESTAT_ONCREATE);
		
		// Verificaci d'estat:
		if(!ESTAT_ONCREATE) {
			// Finalitza l'aplicaci
			finalitza(2);
		}
        
	}

	/*
	 * 
	 */
	@Override
	public void finish() {
		super.finish();
		
		ESTAT_ONCREATE = false;
		intentsLogin = 0;
		usuariAutenticat = false;
		netejacamps();
		
	}
	
	protected void netejacamps() {
		// Esborrar els parmetres usuari i password
		this.setUsuari("");
		this.setPassword("");
		
		// Establim els textes als camps de login
		editUsuari.setText(this.getUsuari());
		editPassword.setText(this.getPassword());
	}

	protected boolean verificaLogin() throws UnsupportedEncodingException, JSONException {
		/*
		 * TODO: METODE PER A L'AUTENTICACI DE L'USUARI
		 * 		1.- Crear el client HTTP per a la comunicaci
		 * 		2.- Crear l'objecte JSON per a enviar el login.
		 * 		3.- Enviar-ho a l'API de la UOC.
		 * 		4.- Agafar les dades de tornada.
		 * 		5.- Verificar les dades.
		 * 		6.- Retornar TRUE o FALSE.
		 * 
		 */
		// Variables locals:
		boolean autenticat = false;
		
		/*
		 * Per autenticar els usuaris dins les aplicacions fem servir l'estndard de l'IMS 
		 * anomenat LTI (Learning Tools Interoperability) 1.1:
		 * 
		 * 		http://www.imsglobal.org/lti/
		 * 		http://www.imsglobal.org/LTI/v1p1/ltiIMGv1p1.html
		 * 
		 * Aquest estandard defineix el LMS (Campus Virtual en el nostre cas) com consumer 
		 * de l'aplicaci i l'aplicaci com provider. 
		 * 
		 * Per l'autenticaci s'ha desenvolupat un llenador:
		 * 
		 * 		https://cv.uoc.edu/webapps/UocBLTI_c/
		 * 
		 * Variables per al llenador:
		 * 
		 * 		S'ha de posar com a mnim els camps username, password, domain i instanceId, on:
		 * 			username	->	s el nom d'usuari
		 * 			password	->	s la contrasenya
		 * 			domain		->	s l'identificador de l'aula (DOMAIN.1 per no indicar aula)
		 * 			instanceId 	->	s l'identificador de l'aplicaci, te'l donarem.
		 * 								(per fer proves pots fer servir el que hi ha per defecte)
		 * 
		 * 		El resultat de la crida mostra el contexte LTI que es pasar a l'aplicaci, 
		 * 		on pots trobar dades de l'usuari com nom, identificador, correu, url de la foto, 
		 * 		perfil actual dins campus, etc., en format JSON
		 * 
		 * Per a fer el Login des d'Android:
		 * 
		 * URL:
		 * 		https://cv.uoc.edu/webapps/UocBLTI_c/BLTIConsumer.launcher
		 * 
		 * Parmetres POST (HTTP):
		 *		provider=		provider_example
		 *		&username=		<nom_usuari>
		 *		&password=		<password>
		 *		&base64Encoded=	0
		 *		&container=		DOMAIN.1
		 *		&instanceId=	EPC-REF.133
		 *		&json_output=	1
		 *		&Submit=		Go%21
		 *
		 * RESPOSTA (JSON):
		 * 		Objecte amb les dades de l'usuari Logat.
		 * 
		 */
		String URL_Llenador = "https://cv.uoc.edu/webapps/UocBLTI_c/BLTIConsumer";
		String provider = "provider_example";
		String username = this.getUsuari();
		String password = this.getPassword();
		String base64Encoded = "0";
		String container = "DOMAIN.1";
		String instanceId = "EPC-REF.133";
		String json_output = "1";
		String Submit = "Go%21";
		
		// DEBUG:
		Log.d("VERIFLOGIN:", "Usuari: " + username);
		Log.d("VERIFLOGIN:", "Password: " + password);
		Log.d("VERIFLOGIN:", "Container: " + container);
		Log.d("VERIFLOGIN:", "InstanceID: " + instanceId);
		Log.d("VERIFLOGIN:", "json_output: " + json_output);
		Log.d("VERIFLOGIN:", "Intents: " + intentsLogin);
		
		// 1.- Crear el client HTTP per a la comunicaci 
		// Creem el client HTTP que ser l'encarregat de la comunicaci
		HttpClient httpClient = new DefaultHttpClient();
		
		// Definim la URL de comunicaci per al login
		HttpPost consulta = new HttpPost(URL_Llenador);
		
		// Establim el contingut de la consulta
		consulta.setHeader("Content-Type", "application/x-www-form-urlencoded");

		// Creem el contenidor per als parmetres del login
		List<NameValuePair> login = new ArrayList<NameValuePair>();
		
		/* 
		 * Fiquem les dades per al login
		 * 
		 *		provider
		 *		username
		 *		password
		 *		container
		 *		instanceId
		 *		base64Encoded
		 *		json_output
		 *		Submit
		 */
		login.add(new BasicNameValuePair("provider", provider));
		login.add(new BasicNameValuePair("username", username));
		login.add(new BasicNameValuePair("password", password));
		login.add(new BasicNameValuePair("container", container));
		login.add(new BasicNameValuePair("instanceId", instanceId));
		login.add(new BasicNameValuePair("base64Encoded", base64Encoded));
		
		// Afegim parmetre per a demanar la reposta en format JSON
		login.add(new BasicNameValuePair("json_output", json_output));
		
		// Tanquem els parmetres POST:
		login.add(new BasicNameValuePair("Submit", Submit));
		
		// Creem una StringEntity per a passar les dades a la crida POST
		HttpEntity entity = new UrlEncodedFormEntity(login);
		
		// consulta.setEntity(entity);
		consulta.setEntity(entity);

		// DEBUG:
		try {
			Log.d("LOGIN - ", "Consulta POST: " + EntityUtils.toString(entity));
			Log.d("LOGIN - ", "Consulta POST login: " + login.toString());
		} catch (ParseException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		// Creem un objecte JSON per a emmagatzemar dades JSON:
		JSONObject respJSON = new JSONObject();
		
		// Verificar mtodo POST + HttpResponse:		
		try {
			// Executem HTTP POST:
			HttpResponse resp = httpClient.execute(consulta);
			String respStr = EntityUtils.toString(resp.getEntity());
			
			// Emmagatzemem la resposta a l'objecte JSON:
			respJSON = new JSONObject(respStr);
			
			// DEBUG:
			Log.d("LOGIN - ", "Resposta POST: " + respStr );
			Log.d("LOGIN - ", "Objecte JSON: " + respJSON.toString());
			
			// Toast per a presentar dades:
			// Toast.makeText(MainActivity.this, "Resposta POST: " + respStr , Toast.LENGTH_LONG).show();
			
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		/* Si l'usuari i password son incorrectes, ens haur retornat:
		 * 		{"ERROR":"NOT AUTHENTICATED!!!"}
		 */
		
		if (respJSON.length() <= 1) {

			// Hi ha un error d'autenticaci
			// DEBUG:
			autenticat = false;
			
			Log.d("LOGIN - ", "CAMPOS: " + respJSON.length() + " - " + respJSON.getString("ERROR"));
			Toast.makeText(MainActivity.this, "ERROR: " 
					+ respJSON.getString("ERROR") 
					+ "\n"
					+ "USUARI O CONTRASENYA\nINCORRECTES", 3).show();
		} else {
			
			/* 
			 * Arribats a aquest punt ja tenim les dades de l'usuari logat al sistema		
			 */
			
			// Emmagatzemem les dades a l'atribut
			userLoged = new UserLoged(respJSON, true);
			
			// Missatge de benvinguda
			Toast.makeText(MainActivity.this, "BENVINGUT: " + respJSON.getString("lis_person_name_given"), 3).show();
			
			autenticat = true;
		}
		
		
		
		// DEBUG: Verificaci del login d'usuari TEMPORAL
		/*
		if ( (username.equals("TEST")) && (password.equals("TEST")) ) {
			autenticat = true;
		} else {
			autenticat = false;
		}
		*/
		
		return autenticat;
	}
	
	/*
	private List<NameValuePair> jsonToNameValuePair(JSONObject respJSON) {
		// TODO Aquest mtode converteix un objecte JSON a una cadena String
		// Tenint en compte
		
		String str = new String();
		List<NameValuePair> nvp = new ArrayList<NameValuePair>();
		nvp.add(new BasicNameValuePair("Submit", Submit));
		
		
		
		
		
		return nvp;
	}
	*/

	/**
	 * @param usuari the usuari to set
	 */
	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}

	/**
	 * @return the usuari
	 */
	public String getUsuari() {
		return usuari;
	}

	/**
	 * @param password the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}
}