/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.util.Random;

import edu.uoc.Android.LiveUOC.Objectes.Aula;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;


public class MostraAulaActivity extends Activity {

	// Atributs per a emmagatzemar una aula i les seves dades:
	private Aula aulaActiva = new Aula();
	private int msgNousTauler;
	private int msgNousForum;
	
	// Variables per als camps de text:
	TextView textMenuAula;
	TextView textMsgNousTauler;
	TextView textMsgNousForum;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
		
        // Recuperem la info. que vrem passar a l'Intent amb el Bundle:
		Bundle extrasLugar = getIntent().getExtras();
		aulaActiva.setCodi(extrasLugar.getString("CODI"));
		aulaActiva.setAssignatura(extrasLugar.getString("ASSIGNATURA"));
		
        // Recollim les dades de la API de la UOC
        recullDadesAula();
        
        // DEBUG:
		Log.d("MOSTRA AULA", "Codi Aula: " + aulaActiva.getCodi());
		Log.d("MOSTRA AULA", "Assignatura Aula: " + aulaActiva.getAssignatura());
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.aula);
        
        /*
         * Capturem els texts cambiables:
         * 		txtMenuAula		->	Ttol de l'aula
         * 		MSGNousTauler	->	Nmero de missatges nous
         * 		MSGNousForum	->	Nmero de missatges nous
         * 
         */
        textMenuAula = (TextView)findViewById(R.id.txtMenuAula);
        textMsgNousTauler = (TextView)findViewById(R.id.MSGNousTauler);
        textMsgNousForum = (TextView)findViewById(R.id.MSGNousForum);
        
        // Establim els textos:
        textMenuAula.setText(aulaActiva.getCodi() + " - " + aulaActiva.getAssignatura());
        textMsgNousTauler.setText("" + msgNousTauler + "]");
        textMsgNousForum.setText("" + msgNousForum + "]");
        
        /*
         * Capturem els botons:
         * 		botoTauler	-> Llena l'activitat Mostra Tauler
         * 		botoForum	-> Llena l'activitat Mostra Forum
         * 		botoSortir	-> Torna enrera
         * 
         */
        final Button botoTauler = (Button) findViewById(R.id.botoTauler);
        final Button botoForum = (Button) findViewById(R.id.botoForum);
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);
        
        // Pulsaci del Bot Tauler
        // Creem el seu onClickListener
        OnClickListener oclbotoTauler = new OnClickListener(){
			public void onClick(View v) {
				// Creem el intent per a llenar l'aplicaci
				Intent intent = new Intent();
				intent.setClass(getApplicationContext(), MostraTaulerActivity.class);
				
				// Creem un bundle per ficar les dades de l'aula
				Bundle bundle = new Bundle();
				// Fiquem les dades de l'aula:
				bundle.putString("CODI", aulaActiva.getCodi());
				bundle.putString("ASSIGNATURA", aulaActiva.getAssignatura());
				// Introdum el Bundle a l'Intent
		        intent.putExtras(bundle);
		        
		        // Llancem l'Activitat associada a l'Intent
				startActivity(intent);
			}
		};        
        // Registrem el seu callback
		botoTauler.setOnClickListener(oclbotoTauler);
		
		// Pulsaci del Bot Forum
        // Creem el seu onClickListener
        OnClickListener oclbotoForum = new OnClickListener(){
			public void onClick(View v) {
				// Creem el intent per a llenar l'aplicaci
				Intent intent = new Intent();
				intent.setClass(getApplicationContext(), MostraForumActivity.class);

				// Creem un bundle per ficar les dades de l'aula
				Bundle bundle = new Bundle();
				// Fiquem les dades de l'aula:
				bundle.putString("CODI", aulaActiva.getCodi());
				bundle.putString("ASSIGNATURA", aulaActiva.getAssignatura());
				// Introdum el Bundle a l'Intent
		        intent.putExtras(bundle);
		        
		        // Llancem l'Activitat associada a l'Intent
				startActivity(intent);
			}
		};        
        // Registrem el seu callback
		botoForum.setOnClickListener(oclbotoForum);
		
        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
       
	}
	
	private void recullDadesAula() {

		// TODO Omplir la resta de dades des de la API de la UOC
		// De moment, ho fiquem aleatori manualment:
		Random randomGenerator = new Random();
		msgNousTauler = randomGenerator.nextInt(50);
		msgNousForum = randomGenerator.nextInt(50);
		
	}

}
