/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.util.Date;

import edu.uoc.Android.LiveUOC.Objectes.Tasca;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;


public class MostraDiaActivity extends Activity {

	// Atribut per a emmagatzemar les aules:
	private Tasca[] LlistaTasques;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Recollim la informaci de les tasques
        getTasques();
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.mostradia);
        
        // Creem l'adapter per ficar la llista d'aules.
        AdaptadorTasques adaptador = new AdaptadorTasques(this);
        
        // Capturem la ID de la vista de llistat
        ListView lstTasques = (ListView)findViewById(R.id.listViewDia);
        
        // Establim el llistat de tasques a la vista, mitjanant l'adapter
        lstTasques.setAdapter(adaptador);
        
        /*
         * Capturem la pulsaci a un tem de la llista
         */
        // Creem el seu onClickListener
        OnItemClickListener oclItemTasca = new OnItemClickListener(){
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				ListAdapter la = (ListAdapter) parent.getAdapter();
				int items = la.getCount();
				
				// DEBUG:
				Log.d("TASQUES", "Tasques: " + items);
				
				if (items>0) {
					// DEBUG:
					Log.d("TASQUES", "Tasca seleccionada: " + position);
					// Mostrem info
					Toast.makeText(
							view.getContext(), 
							"Accedim a la tasca:\n" +
							"NOM: " + LlistaTasques[position].getNom() +
							"\nDESCRIPCI: " + LlistaTasques[position].getDescripcio() , 
							Toast.LENGTH_LONG
							).show();

					// Creem un intent per llenar la sub-activity Mostra Aula
					Intent intent = new Intent();

					// Ho associem amb la Activity a llenar
					intent.setClass(getApplicationContext(), DetallTascaActivity.class);
					
					// Creem un Bundle per passar dades al Intent
					Bundle bundle = new Bundle();
					
					// Fiquem les dades de la tasca:
					bundle.putString("NOM", LlistaTasques[position].getNom());
					bundle.putString("DESCRIPCIO", LlistaTasques[position].getDescripcio());
					bundle.putString("DATA", LlistaTasques[position].getDataFi().toString());
					
					// Introdum el Bundle a l'Intent
			        intent.putExtras(bundle);
			        
					// Llancem l'Activitat associada a l'Intent
					startActivity(intent);
					
				} else {
					Toast.makeText(view.getContext(), "Cap tasca.", Toast.LENGTH_SHORT).show();
				}
		        
			}
		};
        // Registrem el seu callback
		lstTasques.setOnItemClickListener(oclItemTasca);
        
        /*
         * Capturem els botons:
         * 		botoSortir		-> Torna enrera
         * 
         */
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);

        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
        
	}

	class AdaptadorTasques extends ArrayAdapter<Object> {
    	
    	Activity context;
    	
    	AdaptadorTasques(Activity context) {
    		super(context, R.layout.listitemtasca, LlistaTasques);
    		this.context = context;
    	}
    	
    	public View getView(int position, View convertView, ViewGroup parent) {
			LayoutInflater inflater = context.getLayoutInflater();
			View item = inflater.inflate(R.layout.listitemtasca, null);
			
			TextView lblNomTasca = (TextView)item.findViewById(R.id.LstNomTasca);
			lblNomTasca.setText(LlistaTasques[position].getNom());
			
			TextView lblDescripcio = (TextView)item.findViewById(R.id.LstDescripcio);
			lblDescripcio.setText(LlistaTasques[position].getDescripcio());
			
			TextView lblDataFi = (TextView)item.findViewById(R.id.LstDataFi);
			lblDataFi.setText(LlistaTasques[position].getDataFi().toString());
			
			return(item);
		}
    	
    	public long getItemId(int position) { return position; }
    }

	private void getTasques() {
		// TODO Introdum el llistat de tasques
		// Haurem de recorrir les dades retornades per l'API de la UOC
		
		LlistaTasques = new Tasca[]{
	    	new Tasca("Tasca_1", "Descripci tasca 1", new Date()),
	    	new Tasca("Tasca_2", "Descripci tasca 2", new Date()),
	    	new Tasca("Tasca_3", "Descripci tasca 3", new Date())
	    };
		
	}
}
