/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC;

import java.util.Date;

import edu.uoc.Android.LiveUOC.Objectes.Aula;
import edu.uoc.Android.LiveUOC.Objectes.Missatge;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;


public class MostraTaulerActivity extends Activity {

	// Atributs per a emmagatzemar una aula i les seves dades:
	private Aula aulaActiva = new Aula();
	
	// Atribut per a emmagatzemar els missatges:
	private Missatge[] LlistaMissatges;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Recuperem la info. que vrem passar a l'Intent amb el Bundle:
		Bundle extras = getIntent().getExtras();
		aulaActiva.setCodi(extras.getString("CODI"));
		aulaActiva.setAssignatura(extras.getString("ASSIGNATURA"));
        
		// Recollim les dades de la API de la UOC
		getMissatges();
        
        // Mostrem el layout de pantalla
        setContentView(R.layout.llistatmsg);
        
        // Creem l'adapter per ficar la llista d'aules.
        AdaptadorMsg adaptador = new AdaptadorMsg(this);
        
        // Capturem la ID de la vista de llistat
        ListView lstMissatges = (ListView)findViewById(R.id.listViewMsg);
        
        // Establim el llistat d'aules a la vista, mitjanant l'adapter
        lstMissatges.setAdapter(adaptador);
        
        /*
         * Capturem la pulsaci a un tem de la llista
         */
        // Creem el seu onClickListener
        OnItemClickListener oclItemMissatges = new OnItemClickListener(){
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				ListAdapter la = (ListAdapter) parent.getAdapter();
				int items = la.getCount();
				
				// DEBUG:
				Log.d("MISSATGES", "Missatges: " + items);
				
				if (items>0) {
					// DEBUG:
					Log.d("MISSATGES", "Missatge seleccionat: " + position);
					// S'ha de crear un bundle per ficar les dades del missatge
					Toast.makeText(
							view.getContext(), 
							"Accedim al missatge:\n" +
							"Autor: " + LlistaMissatges[position].getAutor() +
							"\nTema: " + LlistaMissatges[position].getTema() +
							"\nData: " + LlistaMissatges[position].getData() , 
							Toast.LENGTH_LONG
							).show();

					// Creem un intent per llenar la sub-activity Mostra Missatge
					Intent intent = new Intent();

					// Ho associem amb la Activity a llenar
					intent.setClass(getApplicationContext(), DetallMsgTaulerActivity.class);
					
					// Creem un Bundle per passar dades al Intent
					Bundle bundle = new Bundle();
					
					// Fiquem les dades del missatge:
					bundle.putString("AUTOR", LlistaMissatges[position].getAutor());
					bundle.putString("TEMA", LlistaMissatges[position].getTema());
					bundle.putString("DATA", LlistaMissatges[position].getData().toString());
					bundle.putString("CODI", aulaActiva.getCodi());
					bundle.putString("ASSIGNATURA", aulaActiva.getAssignatura());
					
					// Introdum el Bundle a l'Intent
			        intent.putExtras(bundle);
			        
					// Llancem l'Activitat associada a l'Intent
					startActivity(intent);
					
				} else {
					Toast.makeText(view.getContext(), "Cap missatge.", Toast.LENGTH_SHORT).show();
				}
		        
			}
		};
        // Registrem el seu callback
		lstMissatges.setOnItemClickListener(oclItemMissatges);
        
        /*
         * Capturem els botons:
         * 		botoSortir		-> Torna enrera
         * 
         */
        final Button botoSortir = (Button) findViewById(R.id.botoSortir);

        // Pulsaci del Bot Sortir
        // Creem el seu onClickListener
        OnClickListener oclbotoSortir = new OnClickListener(){
			public void onClick(View v) {
				finish();
			}
		};        
        // Registrem el seu callback
		botoSortir.setOnClickListener(oclbotoSortir);
		
	}
	
	class AdaptadorMsg extends ArrayAdapter<Object> {
    	
    	Activity context;
    	
    	AdaptadorMsg(Activity context) {
    		super(context, R.layout.listitemmissatge, LlistaMissatges);
    		this.context = context;
    	}
    	
    	public View getView(int position, View convertView, ViewGroup parent) {
			LayoutInflater inflater = context.getLayoutInflater();
			View item = inflater.inflate(R.layout.listitemmissatge, null);
			
			TextView lblData = (TextView)item.findViewById(R.id.LstData);
			lblData.setText(LlistaMissatges[position].getData().toString());
			
			TextView lblAutor = (TextView)item.findViewById(R.id.LstAutor);
			lblAutor.setText(LlistaMissatges[position].getAutor());
			
			TextView LstTema = (TextView)item.findViewById(R.id.LstTema);
			LstTema.setText(LlistaMissatges[position].getTema());
			
			
			
			return(item);
		}
    	
    	public long getItemId(int position) { return position; }
    }

	private void getMissatges() {
		// TODO Introdum el llistat de missatges
		// Haurem de recorrir les dades retornades per l'API de la UOC
		
		LlistaMissatges = new Missatge[]{
	    	new Missatge("Autor_1", "Tema_1", new Date()),
	    	new Missatge("Autor_2", "Tema_2", new Date()),
	    	new Missatge("Autor_3", "Tema_3", new Date())
	    };
		
	}
	
}
