/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */

package edu.uoc.Android.LiveUOC.Objectes;

import java.text.SimpleDateFormat;
import java.util.Date;

import android.net.ParseException;

public class Missatge {

	private String autor;
	private String tema;
	private Date data;
	private String cosMissatge;
	private int uriFoto;
	

	/**
	 * Constructor parametritzat
	 * @param aut L'autor
	 * @param tm El tema
	 * @param dt La data
	 *  
	 */
	public Missatge(String aut, String tm, Date dt){
		autor = aut;
		tema = tm;
		data = dt;
	}

	/*
	 * Constructor buit
	 */
	public Missatge(){
		autor = "";
		tema = "";
		data = new Date();
		cosMissatge = "";
		uriFoto = 0;
	}
	
	/**
	 * Getter
	 * @return autor
	 */
	public String getAutor(){
		return autor;
	}
	
	/**
	 * Getter
	 * @return tema
	 */
	public String getTema(){
		return tema;
	}
	
	/**
	 * Getter
	 * @return data
	 */
	public Date getData(){
		return data;
	}
	
	/**
	 * Setter
	 * @param aut
	 */
	public void setAutor(String aut){
		autor = aut;
	}

	/**
	 * Setter
	 * @param tm
	 */
	public void setTema(String tm){
		tema = tm;
	}
	
	/**
	 * Setter
	 * @param dt
	 */
	public void setData(Date dt){
		data = dt;
	}
	
	/**
	 * Setter
	 * @param dt La data en format String yyyy-MM-dd
	 * @throws java.text.ParseException 
	 */
	public void setData(String dt) throws java.text.ParseException {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
		
		try {
			data = format.parse(dt);
		} catch (ParseException ex) {
		    ex.printStackTrace();
		}
	}

	/**
	 * Setter
	 * @param cosMissatge the cosMissatge to set
	 */
	public void setCosMissatge(String cosMissatge) {
		this.cosMissatge = cosMissatge;
	}

	/**
	 * Getter
	 * @return the cosMissatge
	 */
	public String getCosMissatge() {
		return cosMissatge;
	}

	/**
	 * Setter
	 * @param uriFoto the uriFoto to set
	 */
	public void setUriFoto(int uriFoto) {
		this.uriFoto = uriFoto;
	}

	/**
	 * Getter
	 * @return the uriFoto
	 */
	public int getUriFoto() {
		return uriFoto;
	}

}
