/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */
package edu.uoc.Android.LiveUOC.Objectes;

import java.text.SimpleDateFormat;
import java.util.Date;

import android.net.ParseException;

public class Tasca {

	private String nom;
	private String Descripcio;
	private Date dataFi;
	
	/*
	 * Constructor Buit 
	 */
	public Tasca() {
		this.nom= "";
		this.Descripcio="";
		this.dataFi= new Date();
	}
	
	/*
	 * Constructor parametritzat 
	 */
	public Tasca(String nom, String desc, Date dt) {
		this.nom= nom;
		this.Descripcio=desc;
		this.dataFi= dt;
	}
	
	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param dataFi the dataFi to set
	 */
	public void setDataFi(Date dataFi) {
		this.dataFi = dataFi;
	}
	
	/**
	 * Setter
	 * @param dt La data en format String yyyy-MM-dd
	 * @throws java.text.ParseException 
	 */
	public void setDataFi(String dt) throws java.text.ParseException {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
		
		try {
			dataFi = format.parse(dt);
		} catch (ParseException ex) {
		    ex.printStackTrace();
		}
	}
	
	/**
	 * @return the dataFi
	 */
	public Date getDataFi() {
		return dataFi;
	}

	/**
	 * @param descripcio the descripcio to set
	 */
	public void setDescripcio(String descripcio) {
		Descripcio = descripcio;
	}

	/**
	 * @return the descripcio
	 */
	public String getDescripcio() {
		return Descripcio;
	}
}
