/**
 * Android Application: LiveUOC
 * Treball fi de carrera
 * Universitat Oberta de Catalunya
 * 
 * @author Jose A. Serrano
 *
 */
package edu.uoc.Android.LiveUOC.Objectes;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.entity.StringEntity;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.Log;

/*
 * Classe per a emmagatzemar les dades d'un usuari logejat al sistema.
 * 
 * El constructor rep com a parmetre d'entrada un objecte en format JSON
 * 
 * S'emmagatzemen els atributs:
 * 		- L'objecte JSON rebut
 * 		- Els atributs independents de l'objecte JSON rebut
 * 			TODO: Pendent de revisar si aix s viable...
 * 		- Una llista NameValuePair "CLAU" - "VALOR" dels camps JSON rebuts
 */
public class UserLoged {

	// Atributs JSON
	private JSONObject respJSON = new JSONObject();
	private JSONObject validatJSON = new JSONObject();
	
	// Atribut Llista parelles Nom - Valor
	private List<NameValuePair> parelles = new ArrayList<NameValuePair>();
	
	// Atributs d'usuari implementats:
	private String custom_username = new String();
	private String custom_fullname = new String();
	private String custom_photo = new String();
	
	// Atributs independents:
	// Pendents de implementar segons funcionament de la API
	private String context_id = new String();
	private String context_label = new String();
	private String context_title = new String();
	private String context_type = new String();
	private String custom_0_appid = new String();
	private String custom_0_roleid = new String();
	private String custom_0_subtypedescription = new String();
	private String custom_0_subtypeid = new String();
	private String custom_0_typedescription = new String();
	private String custom_0_typeid = new String();
	private String custom_1_appid = new String();
	private String custom_1_roleid = new String();
	private String custom_1_subtypedescription = new String();
	private String custom_1_subtypeid = new String();
	private String custom_1_typedescription = new String();
	private String custom_1_typeid = new String();
	private String custom_2_appid = new String();
	private String custom_2_roleid = new String();
	private String custom_2_subtypedescription = new String();
	private String custom_2_subtypeid = new String();
	private String custom_2_typedescription = new String();
	private String custom_2_typeid = new String();
	private String custom_3_appid = new String();
	private String custom_3_roleid = new String();
	private String custom_3_subtypedescription = new String();
	private String custom_3_subtypeid = new String();
	private String custom_3_typedescription = new String();
	private String custom_3_typeid = new String();
	private String custom_domain_appid = new String();
	private String custom_domain_borrado = new String();
	private String custom_domain_code = new String();
	private String custom_domain_coditercers = new String();
	private String custom_domain_domainfatherid = new String();
	private String custom_domain_domainlogofile = new String();
	private String custom_domain_id = new String();
	private String custom_domain_pt_template = new String();
	private String custom_domain_scope = new String();
	private String custom_domain_semester = new String();
	private String custom_domain_shorttitle = new String();
	private String custom_domain_title = new String();
	private String custom_domain_typeid = new String();
	private String custom_domain_year = new String();
	private String custom_email = new String();
	private String custom_firstname = new String();
	private String custom_id = new String();
	private String custom_json_output = new String();
	private String custom_lang = new String();
	private String custom_lti_message_encoded_base64 = new String();
	private String custom_lti_message_encoded_iso = new String();
	private String custom_lti_message_encoded_utf8 = new String();
	private String custom_roleappid = new String();
	private String custom_rolecount = new String();
	private String custom_roleid = new String();
	private String custom_rolesubtypeid = new String();
	private String custom_roletypeid = new String();
	private String custom_sessionid = new String();
	private String custom_storage_privatefa_dir = new String();
	private String custom_storage_privatefa_domainid = new String();
	private String custom_storage_privatefa_id = new String();
	private String custom_storage_privatefa_login = new String();
	private String custom_storage_privatefa_stotype_id = new String();
	private String custom_storage_privatefa_stotype_name = new String();
	private String custom_storage_privatefa_stotype_parttypeid = new String();
	private String custom_storage_privatefa_stotype_rights = new String();
	private String custom_storage_privatefa_stotype_title = new String();
	private String custom_storage_privatefa_title = new String();
	private String custom_storage_privatefa_typeid = new String();
	private String custom_subtypedescription = new String();
	private String custom_surname = new String();
	private String custom_typedescription = new String();
	private String custom_user_birthdate = new String();
	private String custom_user_city = new String();
	private String custom_user_gender = new String();
	private String custom_usermailsignature = new String();
	private String custom_usernumber = new String();
	private String custom_value1 = new String();
	private String custom_value2 = new String();
	private String endpoint = new String();
	private String ext_basiclti_submit = new String();
	private String ext_lms = new String();
	private String launch_presentation_document_target = new String();
	private String launch_presentation_height = new String();
	private String launch_presentation_locale = new String();
	private String lis_person_contact_email_primary = new String();
	private String lis_person_name_family = new String();
	private String lis_person_name_full = new String();
	private String lis_person_name_given = new String();
	private String lis_person_sourcedid = new String();
	private String lis_result_sourcedid = new String();
	private String lti_message_type = new String();
	private String lti_version = new String();
	private String oauth_callback = new String();
	private String oauth_consumer_key = new String();
	private String oauth_nonce = new String();
	private String oauth_signature = new String();
	private String oauth_signature_method = new String();
	private String oauth_timestamp = new String();
	private String oauth_version = new String();
	private String resource_link_description = new String();
	private String resource_link_id = new String();
	private String resource_link_title = new String();
	private String roles = new String();
	private String tool_consumer_instance_description = new String();
	private String tool_consumer_instance_guid = new String();
	private String tool_consumer_instance_name = new String();
	private String user_id = new String();
	private String user_image = new String();
	

	/* ---------------------------------------------------------------------------
	 * 	 															CONSTRUCTORS |
	 * ---------------------------------------------------------------------------
	 */
	
	public UserLoged(JSONObject objJSON, boolean validat) {
		/*
		 *  Constructor
		 *  	- Guardar l'objecte JSON
		 *  		bool = FALSE	->	resposta 1
		 *  		bool = TRUE		->	resposta validat
		 *  	- Actualitzar la llista parelles
		 */
		super();
		
		// Actualitzem l'objecte resposta JSON
		if (!validat) {
			setRespJSON(objJSON);
		} else {
			setValidatJSON(objJSON);
			
			// Introdum els atributs implementats:
			try {
				this.setCustom_username(objJSON.getString("custom_username"));
				this.setCustom_fullname(objJSON.getString("custom_fullname"));
				this.setCustom_photo(objJSON.getString("custom_photo"));
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
		// Actualitzem la llista de parelles
		try {
			setParelles(objJSON);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/*
	 * Llista de parelles to HttpEntity, per a fer POST.
	 * 
	 */
	public HttpEntity getHttpEntity() throws UnsupportedEncodingException {
		
		// Actualitzem el camp submit (primer l'esborrem)
		/* ANULAT
		String clau = "ext_basiclti_submit";
		String valor = "";
		try {
			valor = respJSON.getString(clau);
		} catch (JSONException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		this.parelles.remove(clau);
		this.parelles.add(new BasicNameValuePair(clau, valor));
		*/
		
		Log.d("UserLoged - ", "Parelles to String: " + this.parelles.toString() );
		
		HttpEntity entity = new UrlEncodedFormEntity(parelles);
		String stEntity = new String();
		
		try {
			stEntity = parseString(EntityUtils.toString(entity));
		} catch (ParseException e1) {
			// TODO Auto-generated catch block
			Log.d("UserLoged - ", "ParseException: " + stEntity );
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			Log.d("UserLoged - ", "IOException: " + stEntity );
			e1.printStackTrace();
		}
		StringEntity strEntity = new StringEntity(stEntity);
		
		
		// DEBUG:
		Log.d("UserLoged - ", "StringEntity: " + stEntity );
		Log.d("UserLoged - ", "StringEntity: " + strEntity );
		try {
			Log.d("UserLoged - ", "HttpEntity parelles: " + EntityUtils.toString(strEntity) );
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		return strEntity;
	}
	
	
	
	/*
	 * GETTERS i SETTERS Atributs JSON
	 */
	

	/**
	 * @return the respJSON
	 */
	public JSONObject getRespJSON() {
		return respJSON;
	}


	/**
	 * @param respJSON the respJSON to set
	 */
	public void setRespJSON(JSONObject respJSON) {
		this.respJSON = respJSON;
	}


	/**
	 * @return the validatJSON
	 */
	public JSONObject getValidatJSON() {
		return validatJSON;
	}


	/**
	 * @param validatJSON the validatJSON to set
	 */
	public void setValidatJSON(JSONObject validatJSON) {
		this.validatJSON = validatJSON;
	}

	
	/*
	 * GETTERS i SETTERS Llita Parelles Atributs
	 */
	
	/**
	 * @param parelles the parelles to set
	 * @throws JSONException 
	 */
	public void setParelles(JSONObject objJSON) throws JSONException {
		// Variables per a emmagatzemar el parell clau-valor
		String clau = new String();
		String valor = new String();
		
		// Parmetre per a demanar la reposta en format JSON
		String json_output = "1";
		
		
		// Quants parmetres hi ha a l'objecte JSON?
		int numParams = objJSON.length();
		
		// DEBUG:
		Log.d("UserLoged - ", "Nmero de parmetres llegit: " + numParams );
		
		if (numParams>0){
			// Creem arrays de claus i de valors
			JSONArray claus = objJSON.names();
		    JSONArray valors = objJSON.toJSONArray(claus);

			// Recorregut per l'objecte JSON entrat:
			for(int i=0 ; i<numParams ; i++){
				clau = claus.getString(i);
				valor = parseString(valors.getString(i));
				
				/*
				 *  No hem de ficar les claus:
				 *  	custom_json_output
				 *  	endpoint
				 *  
				 *  I el submit el deixarem pel final:
				 *  	ext_basiclti_submit				
				 */
				if (!clau.equals("endpoint") 
				&& !clau.equals("custom_json_output")
				&& !clau.equals("ext_basiclti_submit")) {
					// Existeix la clau?
					if (this.parelles.contains(clau)) {
						// Actualitzem el camp (primer l'esborrem)
						this.parelles.remove(clau);
						this.parelles.add(new BasicNameValuePair(clau, valor));
					} else {
						// Creem el camp
						this.parelles.add(new BasicNameValuePair(clau, valor));
					}
				}
				
			}
			
			// Afegim parmetre per a demanar la reposta en format JSON
			// NO ANULAT:
			// Existeix la clau?
			clau = "json_output";
			valor = json_output;
			if (this.parelles.contains(clau)) {
				// Actualitzem el camp (primer l'esborrem)
				this.parelles.remove(clau);
				this.parelles.add(new BasicNameValuePair(clau, valor));
			} else {
				// Creem el camp
				this.parelles.add(new BasicNameValuePair(clau, valor));
			}
			
			// Afegim el submit al final: ext_basiclti_submit
			// Existeix la clau?
			clau = "ext_basiclti_submit";
			valor = parseString(objJSON.getString(clau));
			if (this.parelles.contains(clau)) {
				// Actualitzem el camp (primer l'esborrem)
				this.parelles.remove(clau);
				this.parelles.add(new BasicNameValuePair(clau, valor));
			} else {
				// Creem el camp
				this.parelles.add(new BasicNameValuePair(clau, valor));
			}
		}
	}

	/**
	 * Parse String: 
	 * 	Mtode per a canviar els carracters URL-encoding al seu ASCII equivalent
	 *
	 *	@param string the string that contains URL-encoding to parse
	 *	@return the string parsed to ASCII
	 *	
	 */
	private String parseString(String string) {
		/* 
		 * TODO  Caracters controlats:
		 * 		URL-e	ASCII
		 * 		%3D		=
		 * 		%2D		+
		 * 		%3A		:
		 */
		// String[] mapa = new String [2];
		String stringTemp = new String();
		
		// DEBUG:
		Log.d("parseString - ", "String original: " + string );
		
		// Processem:
		stringTemp = string.replaceAll("%3D", "=");
		stringTemp = string.replaceAll("%2D", "+");		
		stringTemp = string.replaceAll("%3A", ":");

		// Els espais els transformem en '+':
		stringTemp = string.replaceAll(" ", "+");
		
		// DEBUG:
		Log.d("parseString - ", "String modificat: " + stringTemp );
		
		
		return stringTemp;
	}
	

	/*
	 * GETTERS i SETTERS Atributs independents
	 */
	
	/**
	 * @return the context_id
	 */
	public String getContext_id() {
		return context_id;
	}


	/**
	 * @param context_id the context_id to set
	 */
	public void setContext_id(String context_id) {
		this.context_id = context_id;
	}


	/**
	 * @return the context_label
	 */
	public String getContext_label() {
		return context_label;
	}


	/**
	 * @param context_label the context_label to set
	 */
	public void setContext_label(String context_label) {
		this.context_label = context_label;
	}


	/**
	 * @return the context_title
	 */
	public String getContext_title() {
		return context_title;
	}


	/**
	 * @param context_title the context_title to set
	 */
	public void setContext_title(String context_title) {
		this.context_title = context_title;
	}


	/**
	 * @return the context_type
	 */
	public String getContext_type() {
		return context_type;
	}


	/**
	 * @param context_type the context_type to set
	 */
	public void setContext_type(String context_type) {
		this.context_type = context_type;
	}


	/**
	 * @return the custom_0_appid
	 */
	public String getCustom_0_appid() {
		return custom_0_appid;
	}


	/**
	 * @param custom_0_appid the custom_0_appid to set
	 */
	public void setCustom_0_appid(String custom_0_appid) {
		this.custom_0_appid = custom_0_appid;
	}


	/**
	 * @return the custom_0_roleid
	 */
	public String getCustom_0_roleid() {
		return custom_0_roleid;
	}


	/**
	 * @param custom_0_roleid the custom_0_roleid to set
	 */
	public void setCustom_0_roleid(String custom_0_roleid) {
		this.custom_0_roleid = custom_0_roleid;
	}


	/**
	 * @return the custom_0_subtypedescription
	 */
	public String getCustom_0_subtypedescription() {
		return custom_0_subtypedescription;
	}


	/**
	 * @param custom_0_subtypedescription the custom_0_subtypedescription to set
	 */
	public void setCustom_0_subtypedescription(String custom_0_subtypedescription) {
		this.custom_0_subtypedescription = custom_0_subtypedescription;
	}


	/**
	 * @return the custom_0_subtypeid
	 */
	public String getCustom_0_subtypeid() {
		return custom_0_subtypeid;
	}


	/**
	 * @param custom_0_subtypeid the custom_0_subtypeid to set
	 */
	public void setCustom_0_subtypeid(String custom_0_subtypeid) {
		this.custom_0_subtypeid = custom_0_subtypeid;
	}


	/**
	 * @return the custom_0_typedescription
	 */
	public String getCustom_0_typedescription() {
		return custom_0_typedescription;
	}


	/**
	 * @param custom_0_typedescription the custom_0_typedescription to set
	 */
	public void setCustom_0_typedescription(String custom_0_typedescription) {
		this.custom_0_typedescription = custom_0_typedescription;
	}


	/**
	 * @return the custom_0_typeid
	 */
	public String getCustom_0_typeid() {
		return custom_0_typeid;
	}


	/**
	 * @param custom_0_typeid the custom_0_typeid to set
	 */
	public void setCustom_0_typeid(String custom_0_typeid) {
		this.custom_0_typeid = custom_0_typeid;
	}


	/**
	 * @return the custom_1_appid
	 */
	public String getCustom_1_appid() {
		return custom_1_appid;
	}


	/**
	 * @param custom_1_appid the custom_1_appid to set
	 */
	public void setCustom_1_appid(String custom_1_appid) {
		this.custom_1_appid = custom_1_appid;
	}


	/**
	 * @return the custom_1_roleid
	 */
	public String getCustom_1_roleid() {
		return custom_1_roleid;
	}


	/**
	 * @param custom_1_roleid the custom_1_roleid to set
	 */
	public void setCustom_1_roleid(String custom_1_roleid) {
		this.custom_1_roleid = custom_1_roleid;
	}


	/**
	 * @return the custom_1_subtypedescription
	 */
	public String getCustom_1_subtypedescription() {
		return custom_1_subtypedescription;
	}


	/**
	 * @param custom_1_subtypedescription the custom_1_subtypedescription to set
	 */
	public void setCustom_1_subtypedescription(String custom_1_subtypedescription) {
		this.custom_1_subtypedescription = custom_1_subtypedescription;
	}


	/**
	 * @return the custom_1_subtypeid
	 */
	public String getCustom_1_subtypeid() {
		return custom_1_subtypeid;
	}


	/**
	 * @param custom_1_subtypeid the custom_1_subtypeid to set
	 */
	public void setCustom_1_subtypeid(String custom_1_subtypeid) {
		this.custom_1_subtypeid = custom_1_subtypeid;
	}


	/**
	 * @return the custom_1_typedescription
	 */
	public String getCustom_1_typedescription() {
		return custom_1_typedescription;
	}


	/**
	 * @param custom_1_typedescription the custom_1_typedescription to set
	 */
	public void setCustom_1_typedescription(String custom_1_typedescription) {
		this.custom_1_typedescription = custom_1_typedescription;
	}


	/**
	 * @return the custom_1_typeid
	 */
	public String getCustom_1_typeid() {
		return custom_1_typeid;
	}


	/**
	 * @param custom_1_typeid the custom_1_typeid to set
	 */
	public void setCustom_1_typeid(String custom_1_typeid) {
		this.custom_1_typeid = custom_1_typeid;
	}


	/**
	 * @return the custom_2_appid
	 */
	public String getCustom_2_appid() {
		return custom_2_appid;
	}


	/**
	 * @param custom_2_appid the custom_2_appid to set
	 */
	public void setCustom_2_appid(String custom_2_appid) {
		this.custom_2_appid = custom_2_appid;
	}


	/**
	 * @return the custom_2_roleid
	 */
	public String getCustom_2_roleid() {
		return custom_2_roleid;
	}


	/**
	 * @param custom_2_roleid the custom_2_roleid to set
	 */
	public void setCustom_2_roleid(String custom_2_roleid) {
		this.custom_2_roleid = custom_2_roleid;
	}


	/**
	 * @return the custom_2_subtypedescription
	 */
	public String getCustom_2_subtypedescription() {
		return custom_2_subtypedescription;
	}


	/**
	 * @param custom_2_subtypedescription the custom_2_subtypedescription to set
	 */
	public void setCustom_2_subtypedescription(String custom_2_subtypedescription) {
		this.custom_2_subtypedescription = custom_2_subtypedescription;
	}


	/**
	 * @return the custom_2_subtypeid
	 */
	public String getCustom_2_subtypeid() {
		return custom_2_subtypeid;
	}


	/**
	 * @param custom_2_subtypeid the custom_2_subtypeid to set
	 */
	public void setCustom_2_subtypeid(String custom_2_subtypeid) {
		this.custom_2_subtypeid = custom_2_subtypeid;
	}


	/**
	 * @return the custom_2_typedescription
	 */
	public String getCustom_2_typedescription() {
		return custom_2_typedescription;
	}


	/**
	 * @param custom_2_typedescription the custom_2_typedescription to set
	 */
	public void setCustom_2_typedescription(String custom_2_typedescription) {
		this.custom_2_typedescription = custom_2_typedescription;
	}


	/**
	 * @return the custom_2_typeid
	 */
	public String getCustom_2_typeid() {
		return custom_2_typeid;
	}


	/**
	 * @param custom_2_typeid the custom_2_typeid to set
	 */
	public void setCustom_2_typeid(String custom_2_typeid) {
		this.custom_2_typeid = custom_2_typeid;
	}


	/**
	 * @return the custom_3_appid
	 */
	public String getCustom_3_appid() {
		return custom_3_appid;
	}


	/**
	 * @param custom_3_appid the custom_3_appid to set
	 */
	public void setCustom_3_appid(String custom_3_appid) {
		this.custom_3_appid = custom_3_appid;
	}


	/**
	 * @return the custom_3_roleid
	 */
	public String getCustom_3_roleid() {
		return custom_3_roleid;
	}


	/**
	 * @param custom_3_roleid the custom_3_roleid to set
	 */
	public void setCustom_3_roleid(String custom_3_roleid) {
		this.custom_3_roleid = custom_3_roleid;
	}


	/**
	 * @return the custom_3_subtypedescription
	 */
	public String getCustom_3_subtypedescription() {
		return custom_3_subtypedescription;
	}


	/**
	 * @param custom_3_subtypedescription the custom_3_subtypedescription to set
	 */
	public void setCustom_3_subtypedescription(String custom_3_subtypedescription) {
		this.custom_3_subtypedescription = custom_3_subtypedescription;
	}


	/**
	 * @return the custom_3_subtypeid
	 */
	public String getCustom_3_subtypeid() {
		return custom_3_subtypeid;
	}


	/**
	 * @param custom_3_subtypeid the custom_3_subtypeid to set
	 */
	public void setCustom_3_subtypeid(String custom_3_subtypeid) {
		this.custom_3_subtypeid = custom_3_subtypeid;
	}


	/**
	 * @return the custom_3_typedescription
	 */
	public String getCustom_3_typedescription() {
		return custom_3_typedescription;
	}


	/**
	 * @param custom_3_typedescription the custom_3_typedescription to set
	 */
	public void setCustom_3_typedescription(String custom_3_typedescription) {
		this.custom_3_typedescription = custom_3_typedescription;
	}


	/**
	 * @return the custom_3_typeid
	 */
	public String getCustom_3_typeid() {
		return custom_3_typeid;
	}


	/**
	 * @param custom_3_typeid the custom_3_typeid to set
	 */
	public void setCustom_3_typeid(String custom_3_typeid) {
		this.custom_3_typeid = custom_3_typeid;
	}


	/**
	 * @return the custom_domain_appid
	 */
	public String getCustom_domain_appid() {
		return custom_domain_appid;
	}


	/**
	 * @param custom_domain_appid the custom_domain_appid to set
	 */
	public void setCustom_domain_appid(String custom_domain_appid) {
		this.custom_domain_appid = custom_domain_appid;
	}


	/**
	 * @return the custom_domain_borrado
	 */
	public String getCustom_domain_borrado() {
		return custom_domain_borrado;
	}


	/**
	 * @param custom_domain_borrado the custom_domain_borrado to set
	 */
	public void setCustom_domain_borrado(String custom_domain_borrado) {
		this.custom_domain_borrado = custom_domain_borrado;
	}


	/**
	 * @return the custom_domain_code
	 */
	public String getCustom_domain_code() {
		return custom_domain_code;
	}


	/**
	 * @param custom_domain_code the custom_domain_code to set
	 */
	public void setCustom_domain_code(String custom_domain_code) {
		this.custom_domain_code = custom_domain_code;
	}


	/**
	 * @return the custom_domain_coditercers
	 */
	public String getCustom_domain_coditercers() {
		return custom_domain_coditercers;
	}


	/**
	 * @param custom_domain_coditercers the custom_domain_coditercers to set
	 */
	public void setCustom_domain_coditercers(String custom_domain_coditercers) {
		this.custom_domain_coditercers = custom_domain_coditercers;
	}


	/**
	 * @return the custom_domain_domainfatherid
	 */
	public String getCustom_domain_domainfatherid() {
		return custom_domain_domainfatherid;
	}


	/**
	 * @param custom_domain_domainfatherid the custom_domain_domainfatherid to set
	 */
	public void setCustom_domain_domainfatherid(String custom_domain_domainfatherid) {
		this.custom_domain_domainfatherid = custom_domain_domainfatherid;
	}


	/**
	 * @return the custom_domain_domainlogofile
	 */
	public String getCustom_domain_domainlogofile() {
		return custom_domain_domainlogofile;
	}


	/**
	 * @param custom_domain_domainlogofile the custom_domain_domainlogofile to set
	 */
	public void setCustom_domain_domainlogofile(String custom_domain_domainlogofile) {
		this.custom_domain_domainlogofile = custom_domain_domainlogofile;
	}


	/**
	 * @return the custom_domain_id
	 */
	public String getCustom_domain_id() {
		return custom_domain_id;
	}


	/**
	 * @param custom_domain_id the custom_domain_id to set
	 */
	public void setCustom_domain_id(String custom_domain_id) {
		this.custom_domain_id = custom_domain_id;
	}


	/**
	 * @return the custom_domain_pt_template
	 */
	public String getCustom_domain_pt_template() {
		return custom_domain_pt_template;
	}


	/**
	 * @param custom_domain_pt_template the custom_domain_pt_template to set
	 */
	public void setCustom_domain_pt_template(String custom_domain_pt_template) {
		this.custom_domain_pt_template = custom_domain_pt_template;
	}


	/**
	 * @return the custom_domain_scope
	 */
	public String getCustom_domain_scope() {
		return custom_domain_scope;
	}


	/**
	 * @param custom_domain_scope the custom_domain_scope to set
	 */
	public void setCustom_domain_scope(String custom_domain_scope) {
		this.custom_domain_scope = custom_domain_scope;
	}


	/**
	 * @return the custom_domain_semester
	 */
	public String getCustom_domain_semester() {
		return custom_domain_semester;
	}


	/**
	 * @param custom_domain_semester the custom_domain_semester to set
	 */
	public void setCustom_domain_semester(String custom_domain_semester) {
		this.custom_domain_semester = custom_domain_semester;
	}


	/**
	 * @return the custom_domain_shorttitle
	 */
	public String getCustom_domain_shorttitle() {
		return custom_domain_shorttitle;
	}


	/**
	 * @param custom_domain_shorttitle the custom_domain_shorttitle to set
	 */
	public void setCustom_domain_shorttitle(String custom_domain_shorttitle) {
		this.custom_domain_shorttitle = custom_domain_shorttitle;
	}


	/**
	 * @return the custom_domain_title
	 */
	public String getCustom_domain_title() {
		return custom_domain_title;
	}


	/**
	 * @param custom_domain_title the custom_domain_title to set
	 */
	public void setCustom_domain_title(String custom_domain_title) {
		this.custom_domain_title = custom_domain_title;
	}


	/**
	 * @return the custom_domain_typeid
	 */
	public String getCustom_domain_typeid() {
		return custom_domain_typeid;
	}


	/**
	 * @param custom_domain_typeid the custom_domain_typeid to set
	 */
	public void setCustom_domain_typeid(String custom_domain_typeid) {
		this.custom_domain_typeid = custom_domain_typeid;
	}


	/**
	 * @return the custom_domain_year
	 */
	public String getCustom_domain_year() {
		return custom_domain_year;
	}


	/**
	 * @param custom_domain_year the custom_domain_year to set
	 */
	public void setCustom_domain_year(String custom_domain_year) {
		this.custom_domain_year = custom_domain_year;
	}


	/**
	 * @return the custom_email
	 */
	public String getCustom_email() {
		return custom_email;
	}


	/**
	 * @param custom_email the custom_email to set
	 */
	public void setCustom_email(String custom_email) {
		this.custom_email = custom_email;
	}


	/**
	 * @return the custom_firstname
	 */
	public String getCustom_firstname() {
		return custom_firstname;
	}


	/**
	 * @param custom_firstname the custom_firstname to set
	 */
	public void setCustom_firstname(String custom_firstname) {
		this.custom_firstname = custom_firstname;
	}


	/**
	 * @return the custom_fullname
	 */
	public String getCustom_fullname() {
		return custom_fullname;
	}


	/**
	 * @param custom_fullname the custom_fullname to set
	 */
	public void setCustom_fullname(String custom_fullname) {
		this.custom_fullname = custom_fullname;
	}


	/**
	 * @return the custom_id
	 */
	public String getCustom_id() {
		return custom_id;
	}


	/**
	 * @param custom_id the custom_id to set
	 */
	public void setCustom_id(String custom_id) {
		this.custom_id = custom_id;
	}


	/**
	 * @return the custom_json_output
	 */
	public String getCustom_json_output() {
		return custom_json_output;
	}


	/**
	 * @param custom_json_output the custom_json_output to set
	 */
	public void setCustom_json_output(String custom_json_output) {
		this.custom_json_output = custom_json_output;
	}


	/**
	 * @return the custom_lang
	 */
	public String getCustom_lang() {
		return custom_lang;
	}


	/**
	 * @param custom_lang the custom_lang to set
	 */
	public void setCustom_lang(String custom_lang) {
		this.custom_lang = custom_lang;
	}


	/**
	 * @return the custom_lti_message_encoded_base64
	 */
	public String getCustom_lti_message_encoded_base64() {
		return custom_lti_message_encoded_base64;
	}


	/**
	 * @param custom_lti_message_encoded_base64 the custom_lti_message_encoded_base64 to set
	 */
	public void setCustom_lti_message_encoded_base64(
			String custom_lti_message_encoded_base64) {
		this.custom_lti_message_encoded_base64 = custom_lti_message_encoded_base64;
	}


	/**
	 * @return the custom_lti_message_encoded_iso
	 */
	public String getCustom_lti_message_encoded_iso() {
		return custom_lti_message_encoded_iso;
	}


	/**
	 * @param custom_lti_message_encoded_iso the custom_lti_message_encoded_iso to set
	 */
	public void setCustom_lti_message_encoded_iso(
			String custom_lti_message_encoded_iso) {
		this.custom_lti_message_encoded_iso = custom_lti_message_encoded_iso;
	}


	/**
	 * @return the custom_lti_message_encoded_utf8
	 */
	public String getCustom_lti_message_encoded_utf8() {
		return custom_lti_message_encoded_utf8;
	}


	/**
	 * @param custom_lti_message_encoded_utf8 the custom_lti_message_encoded_utf8 to set
	 */
	public void setCustom_lti_message_encoded_utf8(
			String custom_lti_message_encoded_utf8) {
		this.custom_lti_message_encoded_utf8 = custom_lti_message_encoded_utf8;
	}


	/**
	 * @return the custom_photo
	 */
	public String getCustom_photo() {
		return custom_photo;
	}


	/**
	 * @param custom_photo the custom_photo to set
	 */
	public void setCustom_photo(String custom_photo) {
		this.custom_photo = custom_photo;
	}


	/**
	 * @return the custom_roleappid
	 */
	public String getCustom_roleappid() {
		return custom_roleappid;
	}


	/**
	 * @param custom_roleappid the custom_roleappid to set
	 */
	public void setCustom_roleappid(String custom_roleappid) {
		this.custom_roleappid = custom_roleappid;
	}


	/**
	 * @return the custom_rolecount
	 */
	public String getCustom_rolecount() {
		return custom_rolecount;
	}


	/**
	 * @param custom_rolecount the custom_rolecount to set
	 */
	public void setCustom_rolecount(String custom_rolecount) {
		this.custom_rolecount = custom_rolecount;
	}


	/**
	 * @return the custom_roleid
	 */
	public String getCustom_roleid() {
		return custom_roleid;
	}


	/**
	 * @param custom_roleid the custom_roleid to set
	 */
	public void setCustom_roleid(String custom_roleid) {
		this.custom_roleid = custom_roleid;
	}


	/**
	 * @return the custom_rolesubtypeid
	 */
	public String getCustom_rolesubtypeid() {
		return custom_rolesubtypeid;
	}


	/**
	 * @param custom_rolesubtypeid the custom_rolesubtypeid to set
	 */
	public void setCustom_rolesubtypeid(String custom_rolesubtypeid) {
		this.custom_rolesubtypeid = custom_rolesubtypeid;
	}


	/**
	 * @return the custom_roletypeid
	 */
	public String getCustom_roletypeid() {
		return custom_roletypeid;
	}


	/**
	 * @param custom_roletypeid the custom_roletypeid to set
	 */
	public void setCustom_roletypeid(String custom_roletypeid) {
		this.custom_roletypeid = custom_roletypeid;
	}


	/**
	 * @return the custom_sessionid
	 */
	public String getCustom_sessionid() {
		return custom_sessionid;
	}


	/**
	 * @param custom_sessionid the custom_sessionid to set
	 */
	public void setCustom_sessionid(String custom_sessionid) {
		this.custom_sessionid = custom_sessionid;
	}


	/**
	 * @return the custom_storage_privatefa_dir
	 */
	public String getCustom_storage_privatefa_dir() {
		return custom_storage_privatefa_dir;
	}


	/**
	 * @param custom_storage_privatefa_dir the custom_storage_privatefa_dir to set
	 */
	public void setCustom_storage_privatefa_dir(String custom_storage_privatefa_dir) {
		this.custom_storage_privatefa_dir = custom_storage_privatefa_dir;
	}


	/**
	 * @return the custom_storage_privatefa_domainid
	 */
	public String getCustom_storage_privatefa_domainid() {
		return custom_storage_privatefa_domainid;
	}


	/**
	 * @param custom_storage_privatefa_domainid the custom_storage_privatefa_domainid to set
	 */
	public void setCustom_storage_privatefa_domainid(
			String custom_storage_privatefa_domainid) {
		this.custom_storage_privatefa_domainid = custom_storage_privatefa_domainid;
	}


	/**
	 * @return the custom_storage_privatefa_id
	 */
	public String getCustom_storage_privatefa_id() {
		return custom_storage_privatefa_id;
	}


	/**
	 * @param custom_storage_privatefa_id the custom_storage_privatefa_id to set
	 */
	public void setCustom_storage_privatefa_id(String custom_storage_privatefa_id) {
		this.custom_storage_privatefa_id = custom_storage_privatefa_id;
	}


	/**
	 * @return the custom_storage_privatefa_login
	 */
	public String getCustom_storage_privatefa_login() {
		return custom_storage_privatefa_login;
	}


	/**
	 * @param custom_storage_privatefa_login the custom_storage_privatefa_login to set
	 */
	public void setCustom_storage_privatefa_login(
			String custom_storage_privatefa_login) {
		this.custom_storage_privatefa_login = custom_storage_privatefa_login;
	}


	/**
	 * @return the custom_storage_privatefa_stotype_id
	 */
	public String getCustom_storage_privatefa_stotype_id() {
		return custom_storage_privatefa_stotype_id;
	}


	/**
	 * @param custom_storage_privatefa_stotype_id the custom_storage_privatefa_stotype_id to set
	 */
	public void setCustom_storage_privatefa_stotype_id(
			String custom_storage_privatefa_stotype_id) {
		this.custom_storage_privatefa_stotype_id = custom_storage_privatefa_stotype_id;
	}


	/**
	 * @return the custom_storage_privatefa_stotype_name
	 */
	public String getCustom_storage_privatefa_stotype_name() {
		return custom_storage_privatefa_stotype_name;
	}


	/**
	 * @param custom_storage_privatefa_stotype_name the custom_storage_privatefa_stotype_name to set
	 */
	public void setCustom_storage_privatefa_stotype_name(
			String custom_storage_privatefa_stotype_name) {
		this.custom_storage_privatefa_stotype_name = custom_storage_privatefa_stotype_name;
	}


	/**
	 * @return the custom_storage_privatefa_stotype_parttypeid
	 */
	public String getCustom_storage_privatefa_stotype_parttypeid() {
		return custom_storage_privatefa_stotype_parttypeid;
	}


	/**
	 * @param custom_storage_privatefa_stotype_parttypeid the custom_storage_privatefa_stotype_parttypeid to set
	 */
	public void setCustom_storage_privatefa_stotype_parttypeid(
			String custom_storage_privatefa_stotype_parttypeid) {
		this.custom_storage_privatefa_stotype_parttypeid = custom_storage_privatefa_stotype_parttypeid;
	}


	/**
	 * @return the custom_storage_privatefa_stotype_rights
	 */
	public String getCustom_storage_privatefa_stotype_rights() {
		return custom_storage_privatefa_stotype_rights;
	}


	/**
	 * @param custom_storage_privatefa_stotype_rights the custom_storage_privatefa_stotype_rights to set
	 */
	public void setCustom_storage_privatefa_stotype_rights(
			String custom_storage_privatefa_stotype_rights) {
		this.custom_storage_privatefa_stotype_rights = custom_storage_privatefa_stotype_rights;
	}


	/**
	 * @return the custom_storage_privatefa_stotype_title
	 */
	public String getCustom_storage_privatefa_stotype_title() {
		return custom_storage_privatefa_stotype_title;
	}


	/**
	 * @param custom_storage_privatefa_stotype_title the custom_storage_privatefa_stotype_title to set
	 */
	public void setCustom_storage_privatefa_stotype_title(
			String custom_storage_privatefa_stotype_title) {
		this.custom_storage_privatefa_stotype_title = custom_storage_privatefa_stotype_title;
	}


	/**
	 * @return the custom_storage_privatefa_title
	 */
	public String getCustom_storage_privatefa_title() {
		return custom_storage_privatefa_title;
	}


	/**
	 * @param custom_storage_privatefa_title the custom_storage_privatefa_title to set
	 */
	public void setCustom_storage_privatefa_title(
			String custom_storage_privatefa_title) {
		this.custom_storage_privatefa_title = custom_storage_privatefa_title;
	}


	/**
	 * @return the custom_storage_privatefa_typeid
	 */
	public String getCustom_storage_privatefa_typeid() {
		return custom_storage_privatefa_typeid;
	}


	/**
	 * @param custom_storage_privatefa_typeid the custom_storage_privatefa_typeid to set
	 */
	public void setCustom_storage_privatefa_typeid(
			String custom_storage_privatefa_typeid) {
		this.custom_storage_privatefa_typeid = custom_storage_privatefa_typeid;
	}


	/**
	 * @return the custom_subtypedescription
	 */
	public String getCustom_subtypedescription() {
		return custom_subtypedescription;
	}


	/**
	 * @param custom_subtypedescription the custom_subtypedescription to set
	 */
	public void setCustom_subtypedescription(String custom_subtypedescription) {
		this.custom_subtypedescription = custom_subtypedescription;
	}


	/**
	 * @return the custom_surname
	 */
	public String getCustom_surname() {
		return custom_surname;
	}


	/**
	 * @param custom_surname the custom_surname to set
	 */
	public void setCustom_surname(String custom_surname) {
		this.custom_surname = custom_surname;
	}


	/**
	 * @return the custom_typedescription
	 */
	public String getCustom_typedescription() {
		return custom_typedescription;
	}


	/**
	 * @param custom_typedescription the custom_typedescription to set
	 */
	public void setCustom_typedescription(String custom_typedescription) {
		this.custom_typedescription = custom_typedescription;
	}


	/**
	 * @return the custom_user_birthdate
	 */
	public String getCustom_user_birthdate() {
		return custom_user_birthdate;
	}


	/**
	 * @param custom_user_birthdate the custom_user_birthdate to set
	 */
	public void setCustom_user_birthdate(String custom_user_birthdate) {
		this.custom_user_birthdate = custom_user_birthdate;
	}


	/**
	 * @return the custom_user_city
	 */
	public String getCustom_user_city() {
		return custom_user_city;
	}


	/**
	 * @param custom_user_city the custom_user_city to set
	 */
	public void setCustom_user_city(String custom_user_city) {
		this.custom_user_city = custom_user_city;
	}


	/**
	 * @return the custom_user_gender
	 */
	public String getCustom_user_gender() {
		return custom_user_gender;
	}


	/**
	 * @param custom_user_gender the custom_user_gender to set
	 */
	public void setCustom_user_gender(String custom_user_gender) {
		this.custom_user_gender = custom_user_gender;
	}


	/**
	 * @return the custom_usermailsignature
	 */
	public String getCustom_usermailsignature() {
		return custom_usermailsignature;
	}


	/**
	 * @param custom_usermailsignature the custom_usermailsignature to set
	 */
	public void setCustom_usermailsignature(String custom_usermailsignature) {
		this.custom_usermailsignature = custom_usermailsignature;
	}


	/**
	 * @return the custom_username
	 */
	public String getCustom_username() {
		return custom_username;
	}


	/**
	 * @param custom_username the custom_username to set
	 */
	public void setCustom_username(String custom_username) {
		this.custom_username = custom_username;
	}


	/**
	 * @return the custom_usernumber
	 */
	public String getCustom_usernumber() {
		return custom_usernumber;
	}


	/**
	 * @param custom_usernumber the custom_usernumber to set
	 */
	public void setCustom_usernumber(String custom_usernumber) {
		this.custom_usernumber = custom_usernumber;
	}


	/**
	 * @return the custom_value1
	 */
	public String getCustom_value1() {
		return custom_value1;
	}


	/**
	 * @param custom_value1 the custom_value1 to set
	 */
	public void setCustom_value1(String custom_value1) {
		this.custom_value1 = custom_value1;
	}


	/**
	 * @return the custom_value2
	 */
	public String getCustom_value2() {
		return custom_value2;
	}


	/**
	 * @param custom_value2 the custom_value2 to set
	 */
	public void setCustom_value2(String custom_value2) {
		this.custom_value2 = custom_value2;
	}


	/**
	 * @return the endpoint
	 */
	public String getEndpoint() {
		return endpoint;
	}


	/**
	 * @param endpoint the endpoint to set
	 */
	public void setEndpoint(String endpoint) {
		this.endpoint = endpoint;
	}


	/**
	 * @return the ext_basiclti_submit
	 */
	public String getExt_basiclti_submit() {
		return ext_basiclti_submit;
	}


	/**
	 * @param ext_basiclti_submit the ext_basiclti_submit to set
	 */
	public void setExt_basiclti_submit(String ext_basiclti_submit) {
		this.ext_basiclti_submit = ext_basiclti_submit;
	}


	/**
	 * @return the ext_lms
	 */
	public String getExt_lms() {
		return ext_lms;
	}


	/**
	 * @param ext_lms the ext_lms to set
	 */
	public void setExt_lms(String ext_lms) {
		this.ext_lms = ext_lms;
	}


	/**
	 * @return the launch_presentation_document_target
	 */
	public String getLaunch_presentation_document_target() {
		return launch_presentation_document_target;
	}


	/**
	 * @param launch_presentation_document_target the launch_presentation_document_target to set
	 */
	public void setLaunch_presentation_document_target(
			String launch_presentation_document_target) {
		this.launch_presentation_document_target = launch_presentation_document_target;
	}


	/**
	 * @return the launch_presentation_height
	 */
	public String getLaunch_presentation_height() {
		return launch_presentation_height;
	}


	/**
	 * @param launch_presentation_height the launch_presentation_height to set
	 */
	public void setLaunch_presentation_height(String launch_presentation_height) {
		this.launch_presentation_height = launch_presentation_height;
	}


	/**
	 * @return the launch_presentation_locale
	 */
	public String getLaunch_presentation_locale() {
		return launch_presentation_locale;
	}


	/**
	 * @param launch_presentation_locale the launch_presentation_locale to set
	 */
	public void setLaunch_presentation_locale(String launch_presentation_locale) {
		this.launch_presentation_locale = launch_presentation_locale;
	}


	/**
	 * @return the lis_person_contact_email_primary
	 */
	public String getLis_person_contact_email_primary() {
		return lis_person_contact_email_primary;
	}


	/**
	 * @param lis_person_contact_email_primary the lis_person_contact_email_primary to set
	 */
	public void setLis_person_contact_email_primary(
			String lis_person_contact_email_primary) {
		this.lis_person_contact_email_primary = lis_person_contact_email_primary;
	}


	/**
	 * @return the lis_person_name_family
	 */
	public String getLis_person_name_family() {
		return lis_person_name_family;
	}


	/**
	 * @param lis_person_name_family the lis_person_name_family to set
	 */
	public void setLis_person_name_family(String lis_person_name_family) {
		this.lis_person_name_family = lis_person_name_family;
	}


	/**
	 * @return the lis_person_name_full
	 */
	public String getLis_person_name_full() {
		return lis_person_name_full;
	}


	/**
	 * @param lis_person_name_full the lis_person_name_full to set
	 */
	public void setLis_person_name_full(String lis_person_name_full) {
		this.lis_person_name_full = lis_person_name_full;
	}


	/**
	 * @return the lis_person_name_given
	 */
	public String getLis_person_name_given() {
		return lis_person_name_given;
	}


	/**
	 * @param lis_person_name_given the lis_person_name_given to set
	 */
	public void setLis_person_name_given(String lis_person_name_given) {
		this.lis_person_name_given = lis_person_name_given;
	}


	/**
	 * @return the lis_person_sourcedid
	 */
	public String getLis_person_sourcedid() {
		return lis_person_sourcedid;
	}


	/**
	 * @param lis_person_sourcedid the lis_person_sourcedid to set
	 */
	public void setLis_person_sourcedid(String lis_person_sourcedid) {
		this.lis_person_sourcedid = lis_person_sourcedid;
	}


	/**
	 * @return the lis_result_sourcedid
	 */
	public String getLis_result_sourcedid() {
		return lis_result_sourcedid;
	}


	/**
	 * @param lis_result_sourcedid the lis_result_sourcedid to set
	 */
	public void setLis_result_sourcedid(String lis_result_sourcedid) {
		this.lis_result_sourcedid = lis_result_sourcedid;
	}


	/**
	 * @return the lti_message_type
	 */
	public String getLti_message_type() {
		return lti_message_type;
	}


	/**
	 * @param lti_message_type the lti_message_type to set
	 */
	public void setLti_message_type(String lti_message_type) {
		this.lti_message_type = lti_message_type;
	}


	/**
	 * @return the lti_version
	 */
	public String getLti_version() {
		return lti_version;
	}


	/**
	 * @param lti_version the lti_version to set
	 */
	public void setLti_version(String lti_version) {
		this.lti_version = lti_version;
	}


	/**
	 * @return the oauth_callback
	 */
	public String getOauth_callback() {
		return oauth_callback;
	}


	/**
	 * @param oauth_callback the oauth_callback to set
	 */
	public void setOauth_callback(String oauth_callback) {
		this.oauth_callback = oauth_callback;
	}


	/**
	 * @return the oauth_consumer_key
	 */
	public String getOauth_consumer_key() {
		return oauth_consumer_key;
	}


	/**
	 * @param oauth_consumer_key the oauth_consumer_key to set
	 */
	public void setOauth_consumer_key(String oauth_consumer_key) {
		this.oauth_consumer_key = oauth_consumer_key;
	}


	/**
	 * @return the oauth_nonce
	 */
	public String getOauth_nonce() {
		return oauth_nonce;
	}


	/**
	 * @param oauth_nonce the oauth_nonce to set
	 */
	public void setOauth_nonce(String oauth_nonce) {
		this.oauth_nonce = oauth_nonce;
	}


	/**
	 * @return the oauth_signature
	 */
	public String getOauth_signature() {
		return oauth_signature;
	}


	/**
	 * @param oauth_signature the oauth_signature to set
	 */
	public void setOauth_signature(String oauth_signature) {
		this.oauth_signature = oauth_signature;
	}


	/**
	 * @return the oauth_signature_method
	 */
	public String getOauth_signature_method() {
		return oauth_signature_method;
	}


	/**
	 * @param oauth_signature_method the oauth_signature_method to set
	 */
	public void setOauth_signature_method(String oauth_signature_method) {
		this.oauth_signature_method = oauth_signature_method;
	}


	/**
	 * @return the oauth_timestamp
	 */
	public String getOauth_timestamp() {
		return oauth_timestamp;
	}


	/**
	 * @param oauth_timestamp the oauth_timestamp to set
	 */
	public void setOauth_timestamp(String oauth_timestamp) {
		this.oauth_timestamp = oauth_timestamp;
	}


	/**
	 * @return the oauth_version
	 */
	public String getOauth_version() {
		return oauth_version;
	}


	/**
	 * @param oauth_version the oauth_version to set
	 */
	public void setOauth_version(String oauth_version) {
		this.oauth_version = oauth_version;
	}


	/**
	 * @return the resource_link_description
	 */
	public String getResource_link_description() {
		return resource_link_description;
	}


	/**
	 * @param resource_link_description the resource_link_description to set
	 */
	public void setResource_link_description(String resource_link_description) {
		this.resource_link_description = resource_link_description;
	}


	/**
	 * @return the resource_link_id
	 */
	public String getResource_link_id() {
		return resource_link_id;
	}


	/**
	 * @param resource_link_id the resource_link_id to set
	 */
	public void setResource_link_id(String resource_link_id) {
		this.resource_link_id = resource_link_id;
	}


	/**
	 * @return the resource_link_title
	 */
	public String getResource_link_title() {
		return resource_link_title;
	}


	/**
	 * @param resource_link_title the resource_link_title to set
	 */
	public void setResource_link_title(String resource_link_title) {
		this.resource_link_title = resource_link_title;
	}


	/**
	 * @return the roles
	 */
	public String getRoles() {
		return roles;
	}


	/**
	 * @param roles the roles to set
	 */
	public void setRoles(String roles) {
		this.roles = roles;
	}


	/**
	 * @return the tool_consumer_instance_description
	 */
	public String getTool_consumer_instance_description() {
		return tool_consumer_instance_description;
	}


	/**
	 * @param tool_consumer_instance_description the tool_consumer_instance_description to set
	 */
	public void setTool_consumer_instance_description(
			String tool_consumer_instance_description) {
		this.tool_consumer_instance_description = tool_consumer_instance_description;
	}


	/**
	 * @return the tool_consumer_instance_guid
	 */
	public String getTool_consumer_instance_guid() {
		return tool_consumer_instance_guid;
	}


	/**
	 * @param tool_consumer_instance_guid the tool_consumer_instance_guid to set
	 */
	public void setTool_consumer_instance_guid(String tool_consumer_instance_guid) {
		this.tool_consumer_instance_guid = tool_consumer_instance_guid;
	}


	/**
	 * @return the tool_consumer_instance_name
	 */
	public String getTool_consumer_instance_name() {
		return tool_consumer_instance_name;
	}


	/**
	 * @param tool_consumer_instance_name the tool_consumer_instance_name to set
	 */
	public void setTool_consumer_instance_name(String tool_consumer_instance_name) {
		this.tool_consumer_instance_name = tool_consumer_instance_name;
	}


	/**
	 * @return the user_id
	 */
	public String getUser_id() {
		return user_id;
	}


	/**
	 * @param user_id the user_id to set
	 */
	public void setUser_id(String user_id) {
		this.user_id = user_id;
	}


	/**
	 * @return the user_image
	 */
	public String getUser_image() {
		return user_image;
	}


	/**
	 * @param user_image the user_image to set
	 */
	public void setUser_image(String user_image) {
		this.user_image = user_image;
	}

}
