package edu.uoc.Android.LiveUOC.db;

/*
 * FITXER PER A DEFINIR LA BASE DE DADES, LE SSEVES TAULES I ELS SEUS ATRIBUTS:
 * 		- Nom de la BD.
 * 		- Versi de la BD.
 * 		- Taula Usuaris
 * 		- Taula Aules
 * 		- Taula Tasques
 * 
 * 	TODO: Els camps es llegiran del que ens retorni l'API de la UOC
 * 	i s'omplir la BD amb ells.
 * 	PENDENT D'IMPLEMENTAR AMB L'API DE LA UOC.
 * 		- Missatges_Forum
 * 		- Missatges_Tauler
 * 	
 */

import android.provider.BaseColumns;

public class LiveUOCDB {
	/*
	 * Nom de la base de dades
	 */
	public static final String DB_NAME = "LiveUOC.db";

	/*
	 * versi de la base de dades
	 */
	public static final int DB_VERSION = 1;

	/**
	 * Aquesta clase no ha de ser instanciada
	 */
	private LiveUOCDB () {}

	
	/*
	 * Definici de la taula Usuaris
	 */
	public static final class Usuaris implements BaseColumns {
		/**
		* Aquesta clase no ha de ser instanciada
		*/
		private Usuaris() {}

		/**
		* ordre per defecte (ascendent)
		*/
		public static final String DEFAULT_SORT_ORDER = "_ID ASC";

		/**
		* Abstracci dels noms de camps i taula a constants
		* per a facilitar canvis a la estructura interna de la BD
		*	
		*	ATRIBUT TAULA	TIPUS			CAMP UOC			VALOR EXEMPLE
		* 	_id				nmero enter	custom_id			260608
		* 	username		cadena de text	custom_username		jaserrano
		* 	usernumber		nmero enter	custom_usernumber	496398
		* 	fullname		cadena de text	custom_fullname		Jose Antonio Serrano Romero
		* 	email			cadena de text	custom_email 		jaserrano@uoc.edu
		* 	photo			cadena de text	custom_photo		http://cv.uoc.edu/UOC/mc-icons/fotos/jaserrano.jpg
		* 														(URL cap a la imatge). 
		* 
		*/
		public static final String TAULA_USERS = 	"Usuaris";
		public static final String _ID = 			"_id";
		public static final String USERNAME =		"username";
		public static final String USERNUMBER =		"usernumber";
		public static final String NAME = 			"fullname";
		public static final String EMAIL = 			"email";
		public static final String FOTO = 			"photo";
	}
	
	
	/*
	 * Definici de la taula Aules
	 */
	public static final class Aules implements BaseColumns {
		/**
		* Aquesta clase no ha de ser instanciada
		*/
		private Aules() {}

		/**
		* ordre per defecte (ascendent)
		*/
		public static final String DEFAULT_SORT_ORDER = "_ID ASC";

		/**
		* Abstracci dels noms de camps i taula a constants
		* per a facilitar canvis a la estructura interna de la BD
		*	
		*	ATRIBUT TAULA	TIPUS			CAMP UOC			VALOR EXEMPLE
		* 	_id				nmero enter	-					-
		* 	nom				cadena de text	-					-
		* 	descripcio		cadena de text	-					-
		* 
		*/
		public static final String TAULA_AULES = 	"Aules";
		public static final String _ID = 			"_id";
		public static final String NOM = 			"nom";
		public static final String DESCRIPCIO = 	"descripcio";
	}
	
	
	/*
	 * Definici de la taula Tasques
	 */
	public static final class Tasques implements BaseColumns {
		/**
		* Aquesta clase no ha de ser instanciada
		*/
		private Tasques() {}

		/**
		* ordre per defecte (ascendent)
		*/
		public static final String DEFAULT_SORT_ORDER = "_ID ASC";

		/**
		* Abstracci dels noms de camps i taula a constants
		* per a facilitar canvis a la estructura interna de la BD
		*	
		*	ATRIBUT TAULA	TIPUS			CAMP UOC			VALOR EXEMPLE
		* 	_id				nmero enter	-					-
		* 	nom				cadena de text	-					-
		* 	data			DATA			-					-
		* 	descripcio		cadena de text	-					-
		* 
		*/
		public static final String TAULA_TASQUES = "Tasques";
		public static final String _ID = 			"_id";
		public static final String NOM = 			"nom";
		public static final String DATA = 			"data";
		public static final String DESCRIPCIO = 	"descripcio";
	}
	
}
