package edu.uoc.Android.LiveUOC.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class LiveUOCSQLHelper extends SQLiteOpenHelper {
	/**
	* Constructor
	* @param context
	*/
	public LiveUOCSQLHelper(Context context) {
		super(context, LiveUOCDB.DB_NAME, null, LiveUOCDB.DB_VERSION );
	}
	
	/**
	* Creaci de la base de dades
	*/
	// Sentencia SQL per a crear la taula: Usuaris
    String sqlCreateUsuaris = "CREATE TABLE " + 
    					LiveUOCDB.Usuaris.TAULA_USERS + " (" +
    					LiveUOCDB.Usuaris._ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
    					LiveUOCDB.Usuaris.USERNAME + " TEXT UNIQUE," +
    					LiveUOCDB.Usuaris.USERNUMBER + " TEXT UNIQUE," +
    					LiveUOCDB.Usuaris.NAME + " TEXT UNIQUE," +
    					LiveUOCDB.Usuaris.EMAIL + " TEXT UNIQUE," +
    					LiveUOCDB.Usuaris.FOTO + " TEXT UNIQUE" + 
    					")";

	 // Sentencia SQL per a crear la taula: Aules
    String sqlCreateAules = "CREATE TABLE " + 
						LiveUOCDB.Aules.TAULA_AULES + " (" +
						LiveUOCDB.Aules._ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
						LiveUOCDB.Aules.NOM + " TEXT UNIQUE," +
						LiveUOCDB.Aules.DESCRIPCIO + " TEXT UNIQUE" +
						")";
    
	 // Sentencia SQL per a crear la taula: Tasques
    String sqlCreateTasques = "CREATE TABLE " + 
						LiveUOCDB.Tasques.TAULA_TASQUES + " (" +
						LiveUOCDB.Tasques._ID + " INTEGER PRIMARY KEY AUTOINCREMENT," +
						LiveUOCDB.Tasques.NOM + " TEXT UNIQUE," +
						LiveUOCDB.Tasques.DATA + " DATE," +
						LiveUOCDB.Tasques.DESCRIPCIO + " TEXT UNIQUE" +
						")";

	@Override
	public void onCreate(SQLiteDatabase db) {
		if(db.isReadOnly()) { db=getWritableDatabase(); }
		// Ejecutamos la sentencia para crear la BBDD
		db.execSQL(sqlCreateUsuaris);
		db.execSQL(sqlCreateAules);
		db.execSQL(sqlCreateTasques);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, 
	int newVersion) {
		/* 
		 * Implementar quan hi hagi un canvi de versi.
		 * 		- Crear BD temporal per copiar les dades actuals
		 * 		- Esborrar la BD antiga.
		 * 		- Crear la BD nova, amb la nova estructura.
		 * 		- Copiar les dades.
		 * 		- Esborrar la BD temporal. 		
		 */
		
	}

}

